/*>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>*
	DialogUtils.h
	
		R000 07/20/90 Rocky		Creation.
		R??? 00/00/00 Misc		Misc unrecorded changes.
		R011 12/27/90 Rocky		Change color items to have variable GetColor
								dialog prompt.
								
		R012 02/20/91 dB		New Function SetDoubleTextPlain.
		R013 05/02/91 dB		New Function AddPopUpDynamic. 		
		R014 06/06/91 dB		New routine: GetPopupMenu
		R015 11/25/91 dB		THINK5 compatibility
		R016 3/1/93	  dB		made adjustpopuprects visible
 *<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<*/
#ifndef _H_DialogUtils
#define _H_DialogUtils

#include <StandardDefs.h>

#if THINK4
#include <Color.h>
#include <DialogMgr.h>
#include <MenuMgr.h>
#include <EventMgr.h>
#endif

#ifndef nil
#define	nil	0
#endif

#ifndef Max
#define	Max(a, b)			(((b) > (a)) ? (b) : (a))
#endif

	/** For use with code resources using a4 globals **/
void			UseA4DialogUtils(	void						);
ProcPtr			GetModalFilterProc(	void						);
ProcPtr			GetDrawButtonFrameProc(
									void						);

	/** Centers dialog on screen **/
void			PositionDialog(		ResType			theType,
									short			theID		);

	/** Button Frame User Item Proc **/
pascal void		DrawButtonFrame(	DialogPtr		theDialog,
									short			itemNo		);
pascal void		DrawButtonFrameA4(	DialogPtr		theDialog,
									short			itemNo		);

	/** Frame User Item Proc **/
pascal void		DrawFrame(			DialogPtr		theDialog,
									short			itemNo		);

	/** Convert Edit Text Item to Unsigned Long **/
void			GetULongText(		DialogPtr		theDialog,
									short			itemNo,
									unsigned long *	value,
									unsigned long	lowerBound,
									unsigned long	upperBound);
Boolean			GetULongTextPlain(	DialogPtr		theDialog,
									short			itemNo,
									unsigned long *	value );
void			SetULongText(		DialogPtr		theDialog,
									short			itemNo,
									unsigned long	value		);
void			GetDoubleText(		DialogPtr		theDialog,
									short			itemNo,
									double		  *	value,
									double			lowerBound,
									double			upperBound);
void			GetDoubleTextPrec(	DialogPtr		theDialog,
									short			itemNo,
									double		  *	value,
									double			lowerBound,
									double			upperBound,
									short			precision);
Boolean			GetDoubleTextPlain(	DialogPtr		theDialog,
									short			itemNo,
									double		  *	value );
double			SetDoubleText(		DialogPtr		theDialog,
									short			itemNo,
									double			value		);
void			SetDoubleTextPlain(	DialogPtr		theDialog,
									short			itemNo,
									double			value		);
Boolean			ValidDouble(		char *			floatCString,
									double			*d);
									
	/** Modal Dialog Filter Proc **/
Boolean			PressButton(		DialogPtr		theDialog,
									short			itemNo		);
Boolean			CmdKeyEquivalent(	DialogPtr		theDialog,
									EventRecord*	theEvent,
									short*			itemHit		);
pascal Boolean	ModalFilter(		DialogPtr		theDialog,
									EventRecord*	theEvent,
									short*			itemHit		);
pascal Boolean	ModalFilterA4(		DialogPtr		theDialog,
									EventRecord*	theEvent,
									short*			itemHit		);

	/** Color Picker Dialog Item **/
void			AddColorItem(		DialogPtr		theDialog,
									short			dialogItem,
									RGBColor*		color,
									StringPtr		prompt		);
void			GetColorItem(		short			itemNo,
									RGBColor*		color		);
pascal void		DrawColorItem(		DialogPtr		theDialog,
									short			itemNo		);
void			PickColorItem(		DialogPtr		theDialog,
									short			itemNo		);
void			DisposeColorItems(	void						);
	
	/** PopUp Menu Routines **/
void			AddPopUp(			DialogPtr		theDialog,
									short			theID,
									short			dialogItem,
									short			popUpItem	);
void			AddPopUpDynamic(	DialogPtr		theDialog,
									short			theID,
									MenuHandle		theMenu,
									short			dialogItem,
									short			popUpItem	);
void			AddPopUpPersistent( DialogPtr		theDialog,
									short			theID,
									MenuHandle		theMenu,
									short			dialogItem,
									short			popUpItem );
void			AppendPopUp(		short			itemNo,
									Str255			str			);
void			DeletePopUpItem(	short			itemNo,
									short			popUpItem	);
short			GetPopUpItem(		short			itemNo		);
MenuHandle		GetPopUpMenu(		short			itemNo		);
short			SetPopUpItem(		DialogPtr		theDialog,
									short			itemNo,
									short			menuItem	);
pascal void		DrawPopUp(			DialogPtr		theDialog,
									short			itemNo		);
void			PopUp(				DialogPtr		theDialog,
									short			itemNo		);
void			DisposePopUps(		void						);
void			EnablePopUpEntry(	DialogPtr		theDialog,
									short			itemNo,
									short			menuItem	);
void			DisablePopUpEntry(	DialogPtr		theDialog,
									short			itemNo,
									short			menuItem	);
short			CountPopUpItems(	short			itemNo		);
void 			AdjustPopUpItemRects( DialogPtr	theDialog		);

/* utilities for dialog value checking... */
Boolean			FloatValidate( char *floatStr );
Boolean			IntValidate( char *intStr );
#endif