/* %W%	(Pixar - RenderMan Division)	%G% */

/******************************************************************************
 GeneralDefines.h

		Generally Useful Constant and Macro Definitions
		
	Copyright (c) 1990 PIXAR.  All rights reserved.  This program or
	documentation contains proprietary confidential information and trade
	secrets of PIXAR.  Reverse engineering of object code is prohibited.
	Use of copyright notice is precautionary and does not imply
	publication.

	                      RESTRICTED RIGHTS NOTICE
	
	Use, duplication, or disclosure by the Government is subject to the
	following restrictions:  For civilian agencies, subparagraphs (a) through
	(d) of the Commercial Computer Software--Restricted Rights clause at
	52.227-19 of the FAR; and, for units of the Department of Defense, DoD
	Supplement to the FAR, clause 52.227-7013 (c)(1)(ii), Rights in
	Technical Data and Computer Software.

	Pixar
	3240 Kerner Blvd.
	San Rafael, CA  94901
		
 ******************************************************************************/
 
#ifndef _H_GeneralDefines
#define _H_GeneralDefines

#include <StandardDefs.h>

#define Clamp(a, b, c) Max(Min((a), (c)), (b))

#define ReplaceIfSmaller(a, b) if (((long)a) < ((long)b)) (a) = (b)
#define ReplaceIfBigger(a, b) if (((long)a) > ((long)b)) (a) = (b)

#define TO_LOWER_STR(a) \
{	char *cp; \
	if ((a) != NULL) \
		for (cp = (a);*cp!='\0';cp++) \
			*cp = tolower(*cp); \
}

#define TO_UPPER_STR(a) \
{	char *cp; \
	if ((a) != NULL) \
		for (cp = (a);*cp!='\0';cp++) \
			*cp = toupper(*cp); \
}

#define ReturnErrOnErr(x) { short err; if ((err = (x)) != 0) return(err); }
#define ReturnOnErr(x) { if ((x) != 0) return; }

#endif _H_GeneralDefines

