#ifndef lint
static char     sccsid[] = "%W% (Pixar - RenderMan Division) %G%";
static char     copyrid[] = "Copyright (c) 1990 PIXAR. All rights reserved";
#endif

/******************************************************************************
		
	Copyright (c) 1990 PIXAR.  All rights reserved.  This program or
	documentation contains proprietary confidential information and trade
	secrets of PIXAR.  Reverse engineering of object code is prohibited.
	Use of copyright notice is precautionary and does not imply
	publication.

	                      RESTRICTED RIGHTS NOTICE
	
	Use, duplication, or disclosure by the Government is subject to the
	following restrictions:  For civilian agencies, subparagraphs (a) through
	(d) of the Commercial Computer Software--Restricted Rights clause at
	52.227-19 of the FAR; and, for units of the Department of Defense, DoD
	Supplement to the FAR, clause 52.227-7013 (c)(1)(ii), Rights in
	Technical Data and Computer Software.

	Pixar
	3240 Kerner Blvd.
	San Rafael, CA  94901
		
 ******************************************************************************/

#include "InitToolbox.h"

#include <GeneralDefines.h>

#ifdef applec
#include <QuickDraw.h>
#include <Dialogs.h>
#include <TextEdit.h>
#include <Menus.h>
#include <Windows.h>
#include <Fonts.h>
#endif

/* 
 * QDInit
 *
 * Initializes QuickDraw, initializes the QuickDraw globals and allowing
 * an application to access them. The routine is protected to allow it to
 * be called multiple times without ill effect.
 */

void
QDInit(void)
{
	static InitFlag = 0;
	
	if (!InitFlag) {
#ifdef applec
		InitGraf((Ptr) &qd.thePort);
#else
		InitGraf((Ptr) &thePort);
#endif
		InitFlag = 1;
	}
}

/*
 * InitToolbox
 * 
 * Performs the standard Toolbox initializations which all applications
 * must do
 */

void
InitToolbox(void)
{
	QDInit();

	InitFonts();
	InitWindows();
	InitMenus();
	TEInit();
	InitDialogs(NULL);
	InitCursor();
}

