/* %W%	(Pixar - RenderMan Division)	%G% */

/******************************************************************************
 MacDefines.h

		Macintosh-Specific Constant and Macro Definitions
		
	Copyright (c) 1990 PIXAR.  All rights reserved.  This program or
	documentation contains proprietary confidential information and trade
	secrets of PIXAR.  Reverse engineering of object code is prohibited.
	Use of copyright notice is precautionary and does not imply
	publication.

	                      RESTRICTED RIGHTS NOTICE
	
	Use, duplication, or disclosure by the Government is subject to the
	following restrictions:  For civilian agencies, subparagraphs (a) through
	(d) of the Commercial Computer Software--Restricted Rights clause at
	52.227-19 of the FAR; and, for units of the Department of Defense, DoD
	Supplement to the FAR, clause 52.227-7013 (c)(1)(ii), Rights in
	Technical Data and Computer Software.

	Pixar
	3240 Kerner Blvd.
	San Rafael, CA  94901
		
 ******************************************************************************/

#ifndef _H_MacDefines
#define _H_MacDefines

#include <GeneralDefines.h>
#include <MacGlobals.h>

#define ROOT_DIR_ID 	2

/* Bits for modifiers as returned by GetKeys() in keyMap[1] */
#define kShiftKeyMapMask	0x00000001
#define kCmdKeyMapMask		0x00008000
#define kOptionKeyMapMask	0x00000004

#ifdef THINK_C 	/* In MPW, these are defined in traps.h */
#define _InitGraf						0xA86E
#define _Unimplemented					0xA89F
#define _OSDispatch						0xA88F
#endif

#define _Gestalt						0xA1AD

#define kMacNameStrID					-16413
#define kUserNameStrID					-16096

#define DisposPtrIf(a) if ((a)!=NULL) DisposPtr(a)
#define DisposHandleIf(a) if ((a)!=NULL) DisposHandle(a)

#define ATTRIB_LOCKED (1<<0)
#define ATTRIB_RESOPEN (1<<2)
#define ATTRIB_DATAOPEN (1<<3)
#define ATTRIB_DIRECTORY (1<<4)
#define ATTRIB_OPEN (1<<7)

#define	kCacheBit			4
#define kNoCacheBit			5
#define kReadVerifyBit		6
#define kNewLineBit			7
#define kCacheMask			(1 << kCacheBit)
#define kNoCacheMask		(1 << kNoCacheBit)
#define kReadVerifyMask		(1 << kReadVerifyBit)
#define kNewLineMask		(1 << kNewLineBit)

#define TICKS_PER_SECOND 60

#if 0 /* This test succeeds incorrectly on Powerbooks.  We should be 
         using Gestalt to make this test. */
#define HAVE_AUX (HwCfgFlags & 0x0100)	/* have unix bit test of lomem global, technote 238 */
#endif

#define KeyCharEnter 		0x03
#define KeyCharBackspace	0x08
#define KeyCharTab			0x09
#define KeyCharReturn		0x0d
#define KeyCharClear		0x1b	/* Escape */
#define KeyCharLeftArrow	0x1c
#define KeyCharRightArrow	0x1d
#define KeyCharUpArrow		0x1e
#define KeyCharDownArrow	0x1f

#define srcMerge			127

#if 0
#define SFSaveDisk		(*(short *)0x214)	/* Negative of current volume refnum [WORD]	*/
#define CurDirStore		(*(long *)0x398)	/* DirID of current directory [LONG]		*/
#endif

#define kUseNone		0
#define kUseAppMem		1
#define kUseMFMem		2
#define kUseBiggestMem	3
#define kUseMFMemFirst	4
#define kUseAppMemFirst	5

typedef struct {
	unsigned short		sizeFlags;
	unsigned long		preferredSize;
	unsigned long		minimumSize;
} SIZEResRec, *SIZEResPtr, **SIZEResHandle;

typedef struct {
	OSType	type;
	short	id;
} RsrcSpec;

#endif _H_MacDefines
