#include "RsrcMapStuff.h"

/* Moves the top resource file below the system resource file (in
   the resource chain)
 */

Boolean MoveTopRsrcMapBelowSys(void)
{
	RsrcMapH oldTop;
	
	oldTop = TOP_RSRCMAP_H;
	
	TopMapHndl = (Handle)TOP_RSRCMAP.fNextMap;
	
	(**oldTop).fNextMap = SYS_RSRCMAP.fNextMap;
	SYS_RSRCMAP.fNextMap = oldTop;
	
	if (CurResFile() == (**oldTop).fRefNum)
		UseResFile(TOP_RSRCMAP.fRefNum);
	
	return TRUE;
}

Boolean MoveTopRsrcMapAboveSys(void)
{
	RsrcMapH oldTop, oldAbove;
	
	oldTop = TOP_RSRCMAP_H;
	
	oldAbove = TOP_RSRCMAP_H;
	while (oldAbove != NULL && (**oldAbove).fNextMap != SYS_RSRCMAP_H)
		oldAbove = (**oldAbove).fNextMap;
	
	if (oldTop == NULL || oldAbove == NULL)
		return FALSE;
	
	if (oldTop == oldAbove)
		return TRUE;
	
	TopMapHndl = (Handle)(**oldTop).fNextMap;
	
	(**oldAbove).fNextMap = oldTop;
	(**oldTop).fNextMap = SYS_RSRCMAP_H;
	
	if (CurResFile() == (**oldTop).fRefNum)
		UseResFile(TOP_RSRCMAP.fRefNum);
		
	return TRUE;
}

Boolean InsertRsrcMap(RsrcMapH map, RsrcMapH above, Boolean useIt)
{
	RsrcMapH insertBelow;
	
	if (above == NULL || above == TOP_RSRCMAP_H) {
		(**map).fNextMap = TOP_RSRCMAP_H;
		TopMapHndl = (Handle)map;
	}
	else {
		insertBelow = TOP_RSRCMAP_H;
		while (insertBelow != NULL && (**insertBelow).fNextMap != above)
			insertBelow = (**insertBelow).fNextMap;
		if (insertBelow == NULL)
			return FALSE;
		(**map).fNextMap = above;
		(**insertBelow).fNextMap = map;
	}
	if (useIt)
		UseResFile((**map).fRefNum);
	return TRUE;
}

Boolean RemoveRsrcMap(RsrcMapH map)
{
	RsrcMapH	removeBelow;

	if (map == TOP_RSRCMAP_H)
		TopMapHndl = (Handle)TOP_RSRCMAP.fNextMap;
	else {
		removeBelow = TOP_RSRCMAP_H;
		while (removeBelow != NULL && (**removeBelow).fNextMap != map)
			removeBelow = (**removeBelow).fNextMap;
		if (removeBelow == NULL)
			return FALSE;
		(**removeBelow).fNextMap = (**map).fNextMap;
	}
	if (CurResFile() == (**map).fRefNum)
		if ((**map).fNextMap)
			UseResFile((**(**map).fNextMap).fRefNum);
		else
			UseResFile(TOP_RSRCMAP.fRefNum);
	return TRUE;
}

RsrcMapH FindRsrcMap(short resRef)
{
	RsrcMapH	map;
	
	map = TOP_RSRCMAP_H;
	while (map != NULL && (**map).fRefNum != resRef)
		map = (**map).fNextMap;
	return map;
}

Boolean ChopResourceChain(RsrcMapH map, RsrcMapH *top)
{
	RsrcMapH	nextMap;
	short		curRes;
	Boolean		resetCurRes;
	
	curRes = CurResFile();

	/* Make sure the map is in the list, and check if the CurResFile() is 
	   somewhere in what we're chopping off */
	   
	resetCurRes = (**map).fRefNum == curRes;
	nextMap = TOP_RSRCMAP_H;
	while (nextMap != NULL && nextMap != map) {
		if ((**nextMap).fRefNum == curRes)
			resetCurRes = TRUE;
		nextMap = (**nextMap).fNextMap;
	}
	if (nextMap != map)
		return FALSE;
	
	*top = (RsrcMapH)TopMapHndl;
	TopMapHndl = (Handle)(**map).fNextMap;
	(**map).fNextMap = NULL;
	
	if (resetCurRes)
		UseResFile(TOP_RSRCMAP.fRefNum);
		
	return TRUE;
}

Boolean JoinResourceChains(RsrcMapH top, RsrcMapH aboveMap, Boolean useIt)
{
	RsrcMapH	bottom, joinBelow;
	Boolean		inUse;
	short		curRes;

	if (top == NULL)
		return FALSE;
	
	curRes = CurResFile();

	bottom = top;
	while ((**bottom).fNextMap != NULL)
		bottom = (**bottom).fNextMap;

	if (aboveMap == NULL)
		aboveMap = TOP_RSRCMAP_H;
	
	(**bottom).fNextMap = aboveMap;
	
	if (aboveMap == TOP_RSRCMAP_H) {
		inUse = FALSE;
		TopMapHndl = (Handle)top;
	}
	else {
		joinBelow = TOP_RSRCMAP_H;
		inUse = (**joinBelow).fRefNum == curRes;
		while (joinBelow != NULL && (**joinBelow).fNextMap != aboveMap) {
			joinBelow = (**joinBelow).fNextMap;
			inUse = inUse || (**joinBelow).fRefNum == curRes;
		}
		if (joinBelow == NULL)
			return FALSE;
		(**joinBelow).fNextMap = top;
		if (useIt && !inUse)
			UseResFile((**top).fRefNum);
	}
	return TRUE;
}
