#ifndef _H_WorldStuff
#define _H_WorldStuff

/*==========================================================*/
/*
	File	: WorldStuff.h
	Author	: steve johnson
	
	Routines and defines to test for the existing of system configuration

	Revision History
	
	R0000 12/08/90 SLJ
	-	created
	
	R0001 01/30/91 JW
	-	added other useful trap values
	
	R0002 02/10/91 SLJ
	-	added HasSpecialFolders function (see FolderStuff.[ch])
	

*/
/*==========================================================*/

#ifdef applec
#include <Types.h>
#endif

#define	kUnimplementedTrap		0xA89F

/*Traps used to determine the presence of features */
	
#define tSysEnvirons		0xA090

	/* determines presence of Juggler WaitNextEvent	*/
#define	tWNE				0xA860

	/* determines presence of MultiFinder */
	
#define tOSDispatch			0xA88F

	/* determines presence of color tool box */
#define tOpenCPort			0xAA00

	/* determines presence of Script Manager */
#define tScriptUtil			0xA8B5

	/* determines whether ROM has hier. menu support */
#define tPopupMenuSelect	0xA80B

	/* determines presence of multi-style TextEdit */
#define tTEStylNew			0xA83E

	/* determines presence of Sound Manager */
#define tSndDoCommand		0xA803

	/* determines presence of 32bit quickdraw */
#define tQD32				0xAB03

void SetStack(long stackSize);
long FreeStackSpace(void);

Boolean NTrapAvailable(short theTrap, short itsType);
Boolean HasGestalt(void);

Boolean HasColorQD(void);
Boolean Has32BitQD(void);
Boolean HasSpecialFolders(void);
Boolean CanAllocateTempMem(void);
Boolean CanAllocateTempMemAsReal(void);

short GetSystemVersion(void);

/* Boolean TempMemCallsAvailable(void); */
Boolean CanRunMultipleProcesses(void);

void MMUMode32(void);
void MMUModeBack(void);

Boolean IsCmdPeriod(void);

Boolean AmBackgroundOnly(void);

Boolean HasNewProcessMgr(void);

#endif