#pragma once

#include <ri.h>
#include <stdarg.h>
#include <Components.h>
#include "RiFace_common.h"
#include "RiFace_v.h"

/********** Utility routines **********/

RtInt ri_vectorize(va_list vap, RtToken **args, RtPointer **data);

pascal RiComp_Tokens_Ptr cRiTokens(ComponentInstance inst)
 = {0x2f3c, 0, kRiComp_RibClientTokens, 0x7000, 0xa82a};

/********** V versions of RI routines **********/

pascal ComponentResult cRiVArchiveRecord(ComponentInstance inst, RtToken type, char *format, va_list vap)
 = {0x2f3c, 12, kRiComp_RiVArchiveRecord, 0x7000, 0xa82a};
pascal ComponentResult cRiVMotionBegin(ComponentInstance inst, RtInt n, va_list vap)
 = {0x2f3c, 8, kRiComp_RiVMotionBegin, 0x7000, 0xa82a};

/********** Standard RI routines **********/

pascal ComponentResult cRiAreaLightSourceV(ComponentInstance inst, RtToken name, RtInt n, RtToken tokens[], RtPointer parms[])
 = {0x2f3c, 16, kRiComp_RiAreaLightSourceV, 0x7000, 0xa82a};
pascal ComponentResult cRiLightSourceV(ComponentInstance inst, RtToken name, RtInt n, RtToken tokens[], RtPointer parms[])
 = {0x2f3c, 16, kRiComp_RiLightSourceV, 0x7000, 0xa82a};
pascal ComponentResult cRiObjectBegin(ComponentInstance inst)
 = {0x2f3c, 0, kRiComp_RiObjectBegin, 0x7000, 0xa82a};
pascal ComponentResult cRiTransformPoints(ComponentInstance inst, RtToken fromspace, RtToken tospace, RtInt n, RtPoint points[])
 = {0x2f3c, 16, kRiComp_RiTransformPoints, 0x7000, 0xa82a};
pascal ComponentResult cRiDeclare(ComponentInstance inst, char *name, char *declaration)
 = {0x2f3c, 8, kRiComp_RiDeclare, 0x7000, 0xa82a};
pascal ComponentResult cRiAtmosphereV(ComponentInstance inst, RtToken name, RtInt n, RtToken tokens[], RtPointer parms[])
 = {0x2f3c, 16, kRiComp_RiAtmosphereV, 0x7000, 0xa82a};
pascal ComponentResult cRiAttributeBegin(ComponentInstance inst)
 = {0x2f3c, 0, kRiComp_RiAttributeBegin, 0x7000, 0xa82a};
pascal ComponentResult cRiAttributeEnd(ComponentInstance inst)
 = {0x2f3c, 0, kRiComp_RiAttributeEnd, 0x7000, 0xa82a};
pascal ComponentResult cRiAttributeV(ComponentInstance inst, RtToken name, RtInt n, RtToken tokens[], RtPointer parms[])
 = {0x2f3c, 16, kRiComp_RiAttributeV, 0x7000, 0xa82a};
pascal ComponentResult cRiBasis(ComponentInstance inst, RtBasis ubasis, RtInt ustep, RtBasis vbasis, RtInt vstep)
 = {0x2f3c, 16, kRiComp_RiBasis, 0x7000, 0xa82a};
pascal ComponentResult cRiBegin(ComponentInstance inst, RtToken name)
 = {0x2f3c, 4, kRiComp_RiBegin, 0x7000, 0xa82a};
pascal ComponentResult cRiBound(ComponentInstance inst, RtBound bound)
 = {0x2f3c, 4, kRiComp_RiBound, 0x7000, 0xa82a};
pascal ComponentResult cRiClipping(ComponentInstance inst, RtFloat hither, RtFloat yon)
 = {0x2f3c, 8, kRiComp_RiClipping, 0x7000, 0xa82a};
pascal ComponentResult cRiColor(ComponentInstance inst, RtColor color)
 = {0x2f3c, 4, kRiComp_RiColor, 0x7000, 0xa82a};
pascal ComponentResult cRiColorSamples(ComponentInstance inst, RtInt n, RtFloat nRGB[], RtFloat RGBn[])
 = {0x2f3c, 12, kRiComp_RiColorSamples, 0x7000, 0xa82a};
pascal ComponentResult cRiConcatTransform(ComponentInstance inst, RtMatrix transform)
 = {0x2f3c, 4, kRiComp_RiConcatTransform, 0x7000, 0xa82a};
pascal ComponentResult cRiConeV(ComponentInstance inst, RtFloat height, RtFloat radius, RtFloat tmax, RtInt n, RtToken tokens[], RtPointer parms[])
 = {0x2f3c, 24, kRiComp_RiConeV, 0x7000, 0xa82a};
pascal ComponentResult cRiCoordinateSystem(ComponentInstance inst, RtToken space)
 = {0x2f3c, 4, kRiComp_RiCoordinateSystem, 0x7000, 0xa82a};
pascal ComponentResult cRiCropWindow(ComponentInstance inst, RtFloat xmin, RtFloat xmax, RtFloat ymin, RtFloat ymax)
 = {0x2f3c, 16, kRiComp_RiCropWindow, 0x7000, 0xa82a};
pascal ComponentResult cRiCylinderV(ComponentInstance inst, RtFloat radius, RtFloat zmin, RtFloat zmax, RtFloat tmax, RtInt n, RtToken tokens[], RtPointer parms[])
 = {0x2f3c, 28, kRiComp_RiCylinderV, 0x7000, 0xa82a};
pascal ComponentResult cRiDeformationV(ComponentInstance inst, RtToken name, RtInt n, RtToken tokens[], RtPointer parms[])
 = {0x2f3c, 16, kRiComp_RiDeformationV, 0x7000, 0xa82a};
pascal ComponentResult cRiDepthOfField(ComponentInstance inst, RtFloat fstop, RtFloat focallength, RtFloat focaldistance)
 = {0x2f3c, 12, kRiComp_RiDepthOfField, 0x7000, 0xa82a};
pascal ComponentResult cRiDetail(ComponentInstance inst, RtBound bound)
 = {0x2f3c, 4, kRiComp_RiDetail, 0x7000, 0xa82a};
pascal ComponentResult cRiDetailRange(ComponentInstance inst, RtFloat minvis, RtFloat lowtran, RtFloat uptran, RtFloat maxvis)
 = {0x2f3c, 16, kRiComp_RiDetailRange, 0x7000, 0xa82a};
pascal ComponentResult cRiDiskV(ComponentInstance inst, RtFloat height, RtFloat radius, RtFloat tmax, RtInt n, RtToken tokens[], RtPointer parms[])
 = {0x2f3c, 24, kRiComp_RiDiskV, 0x7000, 0xa82a};
pascal ComponentResult cRiDisplacementV(ComponentInstance inst, RtToken name, RtInt n, RtToken tokens[], RtPointer parms[])
 = {0x2f3c, 16, kRiComp_RiDisplacementV, 0x7000, 0xa82a};
pascal ComponentResult cRiDisplayV(ComponentInstance inst, char *name, RtToken type, RtToken mode, RtInt n, RtToken tokens[], RtPointer parms[])
 = {0x2f3c, 24, kRiComp_RiDisplayV, 0x7000, 0xa82a};
pascal ComponentResult cRiEnd(ComponentInstance inst)
 = {0x2f3c, 0, kRiComp_RiEnd, 0x7000, 0xa82a};
pascal ComponentResult cRiErrorHandler(ComponentInstance inst, RtErrorHandler handler)
 = {0x2f3c, 4, kRiComp_RiErrorHandler, 0x7000, 0xa82a};
pascal ComponentResult cRiExposure(ComponentInstance inst, RtFloat gain, RtFloat gamma)
 = {0x2f3c, 8, kRiComp_RiExposure, 0x7000, 0xa82a};
pascal ComponentResult cRiExteriorV(ComponentInstance inst, RtToken name, RtInt n, RtToken tokens[], RtPointer parms[])
 = {0x2f3c, 16, kRiComp_RiExteriorV, 0x7000, 0xa82a};
pascal ComponentResult cRiFormat(ComponentInstance inst, RtInt xres, RtInt yres, RtFloat aspect)
 = {0x2f3c, 12, kRiComp_RiFormat, 0x7000, 0xa82a};
pascal ComponentResult cRiFrameAspectRatio(ComponentInstance inst, RtFloat aspect)
 = {0x2f3c, 4, kRiComp_RiFrameAspectRatio, 0x7000, 0xa82a};
pascal ComponentResult cRiFrameBegin(ComponentInstance inst, RtInt frame)
 = {0x2f3c, 4, kRiComp_RiFrameBegin, 0x7000, 0xa82a};
pascal ComponentResult cRiFrameEnd(ComponentInstance inst)
 = {0x2f3c, 0, kRiComp_RiFrameEnd, 0x7000, 0xa82a};
pascal ComponentResult cRiGeneralPolygonV(ComponentInstance inst, RtInt nloops, RtInt nverts[], RtInt n, RtToken tokens[], RtPointer parms[])
 = {0x2f3c, 20, kRiComp_RiGeneralPolygonV, 0x7000, 0xa82a};
pascal ComponentResult cRiGeometricApproximation(ComponentInstance inst, RtToken type, RtFloat value)
 = {0x2f3c, 8, kRiComp_RiGeometricApproximation, 0x7000, 0xa82a};
pascal ComponentResult cRiGeometryV(ComponentInstance inst, RtToken type, RtInt n, RtToken tokens[], RtPointer parms[])
 = {0x2f3c, 16, kRiComp_RiGeometryV, 0x7000, 0xa82a};
pascal ComponentResult cRiHiderV(ComponentInstance inst, RtToken type, RtInt n, RtToken tokens[], RtPointer parms[])
 = {0x2f3c, 16, kRiComp_RiHiderV, 0x7000, 0xa82a};
pascal ComponentResult cRiHyperboloidV(ComponentInstance inst, RtPoint point1, RtPoint point2, RtFloat tmax, RtInt n, RtToken tokens[], RtPointer parms[])
 = {0x2f3c, 24, kRiComp_RiHyperboloidV, 0x7000, 0xa82a};
pascal ComponentResult cRiIdentity(ComponentInstance inst)
 = {0x2f3c, 0, kRiComp_RiIdentity, 0x7000, 0xa82a};
pascal ComponentResult cRiIlluminate(ComponentInstance inst, RtLightHandle light, RtBoolean onoff)
 = {0x2f3c, 6, kRiComp_RiIlluminate, 0x7000, 0xa82a};
pascal ComponentResult cRiImagerV(ComponentInstance inst, RtToken name, RtInt n, RtToken tokens[], RtPointer parms[])
 = {0x2f3c, 16, kRiComp_RiImagerV, 0x7000, 0xa82a};
pascal ComponentResult cRiInteriorV(ComponentInstance inst, RtToken name, RtInt n, RtToken tokens[], RtPointer parms[])
 = {0x2f3c, 16, kRiComp_RiInteriorV, 0x7000, 0xa82a};
pascal ComponentResult cRiMakeBumpV(ComponentInstance inst, char *pic, char *tex, RtToken swrap, RtToken twrap, RtFilterFunc filterfunc, RtFloat swidth, RtFloat twidth,RtInt n, RtToken tokens[], RtPointer parms[])
 = {0x2f3c, 40, kRiComp_RiMakeBumpV, 0x7000, 0xa82a};
pascal ComponentResult cRiMakeCubeFaceEnvironmentV(ComponentInstance inst, char *px, char *nx, char *py, char *ny, char *pz, char *nz, char *tex, RtFloat fov, RtFilterFunc filterfunc, RtFloat swidth, RtFloat ywidth, RtInt n, RtToken tokens[], RtPointer parms[])
 = {0x2f3c, 56, kRiComp_RiMakeCubeFaceEnvironmentV, 0x7000, 0xa82a};
pascal ComponentResult cRiMakeLatLongEnvironmentV(ComponentInstance inst, char *pic, char *tex, RtFilterFunc filterfunc, RtFloat swidth, RtFloat twidth, RtInt n, RtToken tokens[], RtPointer parms[])
 = {0x2f3c, 32, kRiComp_RiMakeLatLongEnvironmentV, 0x7000, 0xa82a};
pascal ComponentResult cRiMakeShadowV(ComponentInstance inst, char *pic, char *tex, RtInt n, RtToken tokens[], RtPointer parms[])
 = {0x2f3c, 20, kRiComp_RiMakeShadowV, 0x7000, 0xa82a};
pascal ComponentResult cRiMakeTextureV(ComponentInstance inst, char *pic, char *tex, RtToken swrap, RtToken twrap, RtFilterFunc filterfunc, RtFloat swidth, RtFloat twidth, RtInt n, RtToken tokens[], RtPointer parms[])
 = {0x2f3c, 40, kRiComp_RiMakeTextureV, 0x7000, 0xa82a};
pascal ComponentResult cRiMatte(ComponentInstance inst, RtBoolean onoff)
 = {0x2f3c, 2, kRiComp_RiMatte, 0x7000, 0xa82a};
pascal ComponentResult cRiMotionBeginV(ComponentInstance inst, RtInt n, RtFloat times[])
 = {0x2f3c, 8, kRiComp_RiMotionBeginV, 0x7000, 0xa82a};
pascal ComponentResult cRiMotionEnd(ComponentInstance inst)
 = {0x2f3c, 0, kRiComp_RiMotionEnd, 0x7000, 0xa82a};
pascal ComponentResult cRiNuPatchV(ComponentInstance inst, RtInt nu, RtInt uorder, RtFloat uknot[], RtFloat umin, RtFloat umax, RtInt nv, RtInt vorder, RtFloat vknot[], RtFloat vmin, RtFloat vmax, RtInt n, RtToken tokens[], RtPointer parms[])
 = {0x2f3c, 52, kRiComp_RiNuPatchV, 0x7000, 0xa82a};
pascal ComponentResult cRiObjectEnd(ComponentInstance inst)
 = {0x2f3c, 0, kRiComp_RiObjectEnd, 0x7000, 0xa82a};
pascal ComponentResult cRiObjectInstance(ComponentInstance inst, RtObjectHandle handle)
 = {0x2f3c, 4, kRiComp_RiObjectInstance, 0x7000, 0xa82a};
pascal ComponentResult cRiOpacity(ComponentInstance inst, RtColor color)
 = {0x2f3c, 4, kRiComp_RiOpacity, 0x7000, 0xa82a};
pascal ComponentResult cRiOptionV(ComponentInstance inst, RtToken name, RtInt n, RtToken tokens[], RtPointer parms[])
 = {0x2f3c, 16, kRiComp_RiOptionV, 0x7000, 0xa82a};
pascal ComponentResult cRiOrientation(ComponentInstance inst, RtToken orientation)
 = {0x2f3c, 4, kRiComp_RiOrientation, 0x7000, 0xa82a};
pascal ComponentResult cRiParaboloidV(ComponentInstance inst, RtFloat rmax, RtFloat zmin, RtFloat zmax, RtFloat tmax, RtInt n, RtToken tokens[], RtPointer parms[])
 = {0x2f3c, 28, kRiComp_RiParaboloidV, 0x7000, 0xa82a};
pascal ComponentResult cRiPatchMeshV(ComponentInstance inst, RtToken type, RtInt nu, RtToken uwrap, RtInt nv, RtToken vwrap, RtInt n, RtToken tokens[], RtPointer parms[])
 = {0x2f3c, 32, kRiComp_RiPatchMeshV, 0x7000, 0xa82a};
pascal ComponentResult cRiPatchV(ComponentInstance inst, RtToken type, RtInt n, RtToken tokens[], RtPointer parms[])
 = {0x2f3c, 16, kRiComp_RiPatchV, 0x7000, 0xa82a};
pascal ComponentResult cRiPerspective(ComponentInstance inst, RtFloat fov)
 = {0x2f3c, 4, kRiComp_RiPerspective, 0x7000, 0xa82a};
pascal ComponentResult cRiPixelFidelity(ComponentInstance inst, RtFloat variation)
 = {0x2f3c, 4, kRiComp_RiPixelFidelity, 0x7000, 0xa82a};
pascal ComponentResult cRiPixelFilter(ComponentInstance inst, RtFilterFunc filterfunc, RtFloat xwidth, RtFloat ywidth)
 = {0x2f3c, 12, kRiComp_RiPixelFilter, 0x7000, 0xa82a};
pascal ComponentResult cRiPixelSamples(ComponentInstance inst, RtFloat xsamples, RtFloat ysamples)
 = {0x2f3c, 8, kRiComp_RiPixelSamples, 0x7000, 0xa82a};
pascal ComponentResult cRiPixelVariance(ComponentInstance inst, RtFloat variation)
 = {0x2f3c, 4, kRiComp_RiPixelVariance, 0x7000, 0xa82a};
pascal ComponentResult cRiPointsGeneralPolygonsV(ComponentInstance inst, RtInt npolys, RtInt nloops[], RtInt nverts[], RtInt verts[], RtInt n, RtToken tokens[], RtPointer parms[])
 = {0x2f3c, 28, kRiComp_RiPointsGeneralPolygonsV, 0x7000, 0xa82a};
pascal ComponentResult cRiPointsPolygonsV(ComponentInstance inst, RtInt npolys, RtInt nverts[], RtInt verts[], RtInt n, RtToken tokens[], RtPointer parms[])
 = {0x2f3c, 24, kRiComp_RiPointsPolygonsV, 0x7000, 0xa82a};
pascal ComponentResult cRiPolygonV(ComponentInstance inst, RtInt nverts, RtInt n, RtToken tokens[], RtPointer parms[])
 = {0x2f3c, 16, kRiComp_RiPolygonV, 0x7000, 0xa82a};
pascal ComponentResult cRiProcedural(ComponentInstance inst, RtPointer data, RtBound bound, RtVoid (*subdivfunc)(RtPointer, RtFloat), RtVoid (*freefunc)(RtPointer))
 = {0x2f3c, 16, kRiComp_RiProcedural, 0x7000, 0xa82a};
pascal ComponentResult cRiProjectionV(ComponentInstance inst, RtToken name, RtInt n, RtToken tokens[], RtPointer parms[])
 = {0x2f3c, 16, kRiComp_RiProjectionV, 0x7000, 0xa82a};
pascal ComponentResult cRiQuantize(ComponentInstance inst, RtToken type, RtInt one, RtInt min, RtInt max, RtFloat ampl)
 = {0x2f3c, 20, kRiComp_RiQuantize, 0x7000, 0xa82a};
pascal ComponentResult cRiRelativeDetail(ComponentInstance inst, RtFloat relativedetail)
 = {0x2f3c, 4, kRiComp_RiRelativeDetail, 0x7000, 0xa82a};
pascal ComponentResult cRiReverseOrientation(ComponentInstance inst)
 = {0x2f3c, 0, kRiComp_RiReverseOrientation, 0x7000, 0xa82a};
pascal ComponentResult cRiRotate(ComponentInstance inst, RtFloat angle, RtFloat dx, RtFloat dy, RtFloat dz)
 = {0x2f3c, 16, kRiComp_RiRotate, 0x7000, 0xa82a};
pascal ComponentResult cRiScale(ComponentInstance inst, RtFloat sx, RtFloat sy, RtFloat sz)
 = {0x2f3c, 12, kRiComp_RiScale, 0x7000, 0xa82a};
pascal ComponentResult cRiScreenWindow(ComponentInstance inst, RtFloat left, RtFloat right, RtFloat top, RtFloat bot)
 = {0x2f3c, 16, kRiComp_RiScreenWindow, 0x7000, 0xa82a};
pascal ComponentResult cRiShadingInterpolation(ComponentInstance inst, RtToken type)
 = {0x2f3c, 4, kRiComp_RiShadingInterpolation, 0x7000, 0xa82a};
pascal ComponentResult cRiShadingRate(ComponentInstance inst, RtFloat size)
 = {0x2f3c, 4, kRiComp_RiShadingRate, 0x7000, 0xa82a};
pascal ComponentResult cRiShutter(ComponentInstance inst, RtFloat min, RtFloat max)
 = {0x2f3c, 8, kRiComp_RiShutter, 0x7000, 0xa82a};
pascal ComponentResult cRiSides(ComponentInstance inst, RtInt sides)
 = {0x2f3c, 4, kRiComp_RiSides, 0x7000, 0xa82a};
pascal ComponentResult cRiSkew(ComponentInstance inst, RtFloat angle, RtFloat dx1, RtFloat dy1, RtFloat dz1, RtFloat dx2, RtFloat dy2, RtFloat dz2)
 = {0x2f3c, 28, kRiComp_RiSkew, 0x7000, 0xa82a};
pascal ComponentResult cRiSolidBegin(ComponentInstance inst, RtToken operation)
 = {0x2f3c, 4, kRiComp_RiSolidBegin, 0x7000, 0xa82a};
pascal ComponentResult cRiSolidEnd(ComponentInstance inst)
 = {0x2f3c, 0, kRiComp_RiSolidEnd, 0x7000, 0xa82a};
pascal ComponentResult cRiSphereV(ComponentInstance inst, RtFloat radius, RtFloat zmin, RtFloat zmax, RtFloat tmax, RtInt n, RtToken tokens[], RtPointer parms[])
 = {0x2f3c, 28, kRiComp_RiSphereV, 0x7000, 0xa82a};
pascal ComponentResult cRiSurfaceV(ComponentInstance inst, RtToken name, RtInt n, RtToken tokens[], RtPointer parms[])
 = {0x2f3c, 16, kRiComp_RiSurfaceV, 0x7000, 0xa82a};
pascal ComponentResult cRiTextureCoordinates(ComponentInstance inst, RtFloat s1, RtFloat t1, RtFloat s2, RtFloat t2, RtFloat s3, RtFloat t3, RtFloat s4, RtFloat t4)
 = {0x2f3c, 32, kRiComp_RiTextureCoordinates, 0x7000, 0xa82a};
pascal ComponentResult cRiTorusV(ComponentInstance inst, RtFloat majrad, RtFloat minrad, RtFloat phimin, RtFloat phimax, RtFloat tmax, RtInt n, RtToken tokens[], RtPointer parms[])
 = {0x2f3c, 32, kRiComp_RiTorusV, 0x7000, 0xa82a};
pascal ComponentResult cRiTransform(ComponentInstance inst, RtMatrix transform)
 = {0x2f3c, 4, kRiComp_RiTransform, 0x7000, 0xa82a};
pascal ComponentResult cRiTransformBegin(ComponentInstance inst)
 = {0x2f3c, 0, kRiComp_RiTransformBegin, 0x7000, 0xa82a};
pascal ComponentResult cRiTransformEnd(ComponentInstance inst)
 = {0x2f3c, 0, kRiComp_RiTransformEnd, 0x7000, 0xa82a};
pascal ComponentResult cRiTranslate(ComponentInstance inst, RtFloat dx, RtFloat dy, RtFloat dz)
 = {0x2f3c, 12, kRiComp_RiTranslate, 0x7000, 0xa82a};
pascal ComponentResult cRiTrimCurve(ComponentInstance inst, RtInt nloops, RtInt ncurves[], RtInt order[], RtFloat knot[], RtFloat min[], RtFloat max[], RtInt n[], RtFloat u[], RtFloat v[], RtFloat w[])
 = {0x2f3c, 40, kRiComp_RiTrimCurve, 0x7000, 0xa82a};
pascal ComponentResult cRiWorldBegin(ComponentInstance inst)
 = {0x2f3c, 0, kRiComp_RiWorldBegin, 0x7000, 0xa82a};
pascal ComponentResult cRiWorldEnd(ComponentInstance inst)
 = {0x2f3c, 0, kRiComp_RiWorldEnd, 0x7000, 0xa82a};

