#pragma once

#include <ri.h>

#define kRiComp_FirstSelector						997
#define kRiComp_LastSelector						1094

#define kRiComp_RibClientTokens						997

#define kRiComp_RiVArchiveRecord					998
#define kRiComp_RiVMotionBegin						999

#define kRiComp_RiAreaLightSourceV					1000
#define kRiComp_RiLightSourceV						1001
#define kRiComp_RiObjectBegin						1002
#define kRiComp_RiTransformPoints					1003
#define kRiComp_RiDeclare							1004
#define kRiComp_RiAtmosphereV						1005
#define kRiComp_RiAttributeBegin					1006
#define kRiComp_RiAttributeEnd						1007
#define kRiComp_RiAttributeV						1008
#define kRiComp_RiBasis								1009
#define kRiComp_RiBegin								1010
#define kRiComp_RiBound								1011
#define kRiComp_RiClipping							1012
#define kRiComp_RiColor								1013
#define kRiComp_RiColorSamples						1014
#define kRiComp_RiConcatTransform					1015
#define kRiComp_RiConeV								1016
#define kRiComp_RiCoordinateSystem					1017
#define kRiComp_RiCropWindow						1018
#define kRiComp_RiCylinderV							1019
#define kRiComp_RiDeformationV						1020
#define kRiComp_RiDepthOfField						1021
#define kRiComp_RiDetail							1022
#define kRiComp_RiDetailRange						1023
#define kRiComp_RiDiskV								1024
#define kRiComp_RiDisplacementV						1025
#define kRiComp_RiDisplayV							1026
#define kRiComp_RiEnd								1027
#define kRiComp_RiErrorHandler						1028
#define kRiComp_RiExposure							1029
#define kRiComp_RiExteriorV							1030
#define kRiComp_RiFormat							1031
#define kRiComp_RiFrameAspectRatio					1032
#define kRiComp_RiFrameBegin						1033
#define kRiComp_RiFrameEnd							1034
#define kRiComp_RiGeneralPolygonV					1035
#define kRiComp_RiGeometricApproximation			1036
#define kRiComp_RiGeometryV							1037
#define kRiComp_RiHiderV							1038
#define kRiComp_RiHyperboloidV						1039
#define kRiComp_RiIdentity							1040
#define kRiComp_RiIlluminate						1041
#define kRiComp_RiImagerV							1042
#define kRiComp_RiInteriorV							1043
#define kRiComp_RiMakeBumpV							1044
#define kRiComp_RiMakeCubeFaceEnvironmentV			1045
#define kRiComp_RiMakeLatLongEnvironmentV			1046
#define kRiComp_RiMakeShadowV						1047
#define kRiComp_RiMakeTextureV						1048
#define kRiComp_RiMatte								1049
#define kRiComp_RiMotionBeginV						1050
#define kRiComp_RiMotionEnd							1051
#define kRiComp_RiNuPatchV							1052
#define kRiComp_RiObjectEnd							1053
#define kRiComp_RiObjectInstance					1054
#define kRiComp_RiOpacity							1055
#define kRiComp_RiOptionV							1056
#define kRiComp_RiOrientation						1057
#define kRiComp_RiParaboloidV						1058
#define kRiComp_RiPatchMeshV						1059
#define kRiComp_RiPatchV							1060
#define kRiComp_RiPerspective						1061
#define kRiComp_RiPixelFidelity						1062
#define kRiComp_RiPixelFilter						1063
#define kRiComp_RiPixelSamples						1064
#define kRiComp_RiPixelVariance						1065
#define kRiComp_RiPointsGeneralPolygonsV			1066
#define kRiComp_RiPointsPolygonsV					1067
#define kRiComp_RiPolygonV							1068
#define kRiComp_RiProcedural						1069
#define kRiComp_RiProjectionV						1070
#define kRiComp_RiQuantize							1071
#define kRiComp_RiRelativeDetail					1072
#define kRiComp_RiReverseOrientation				1073
#define kRiComp_RiRotate							1074
#define kRiComp_RiScale								1075
#define kRiComp_RiScreenWindow						1076
#define kRiComp_RiShadingInterpolation				1077
#define kRiComp_RiShadingRate						1078
#define kRiComp_RiShutter							1079
#define kRiComp_RiSides								1080
#define kRiComp_RiSkew								1081
#define kRiComp_RiSolidBegin						1082
#define kRiComp_RiSolidEnd							1083
#define kRiComp_RiSphereV							1084
#define kRiComp_RiSurfaceV							1085
#define kRiComp_RiTextureCoordinates				1086
#define kRiComp_RiTorusV							1087
#define kRiComp_RiTransform							1088
#define kRiComp_RiTransformBegin					1089
#define kRiComp_RiTransformEnd						1090
#define kRiComp_RiTranslate							1091
#define kRiComp_RiTrimCurve							1092
#define kRiComp_RiWorldBegin						1093
#define kRiComp_RiWorldEnd							1094

typedef struct {
	RtBasis			*tRiBezierBasis;
	RtBasis			*tRiCatmullRomBasis;
	RtBasis			*tRiBSplineBasis;
	RtBasis			*tRiHermiteBasis;
	RtBasis			*tRiPowerBasis;

	RtFilterFunc	tRiGaussianFilter;
	RtFilterFunc	tRiBoxFilter;
	RtFilterFunc	tRiTriangleFilter;
	RtFilterFunc	tRiCatmullRomFilter;
	RtFilterFunc	tRiSincFilter;
	RtFilterFunc	tRiBesselFilter;

	RtInt			*tRiLastError;
	
	RtErrorHandler	tRiErrorIgnore;
	RtErrorHandler	tRiErrorPrint;
	RtErrorHandler	tRiErrorAbort;

	RtToken			*tRI_FRAMEBUFFER;
	RtToken			*tRI_FILE;
	RtToken			*tRI_RGB;
	RtToken			*tRI_RGBA;
	RtToken			*tRI_RGBZ;
	RtToken			*tRI_RGBAZ;
	RtToken			*tRI_A;
	RtToken			*tRI_Z;
	RtToken			*tRI_AZ;
	RtToken			*tRI_PERSPECTIVE;
	RtToken			*tRI_ORTHOGRAPHIC;
	RtToken			*tRI_HIDDEN;
	RtToken			*tRI_PAINT;
	RtToken			*tRI_CONSTANT;
	RtToken			*tRI_SMOOTH;
	RtToken			*tRI_ORIGIN;
	RtToken			*tRI_FLATNESS;
	RtToken			*tRI_MOTIONFACTOR;
	RtToken			*tRI_TRIMDEVIATION;
	RtToken			*tRI_FOV;
	RtToken			*tRI_AMBIENTLIGHT;
	RtToken			*tRI_POINTLIGHT;
	RtToken			*tRI_DISTANTLIGHT;
	RtToken			*tRI_SPOTLIGHT;
	RtToken			*tRI_INTENSITY;
	RtToken			*tRI_LIGHTCOLOR;
	RtToken			*tRI_FROM;
	RtToken			*tRI_TO;
	RtToken			*tRI_CONEANGLE;
	RtToken			*tRI_CONEDELTAANGLE;
	RtToken			*tRI_BEAMDISTRIBUTION;
	RtToken			*tRI_MATTE;
	RtToken			*tRI_METAL;
	RtToken			*tRI_SHINYMETAL;
	RtToken			*tRI_PLASTIC;
	RtToken			*tRI_PAINTEDPLASTIC;
	RtToken			*tRI_KA;
	RtToken			*tRI_KD;
	RtToken			*tRI_KS;
	RtToken			*tRI_ROUGHNESS;
	RtToken			*tRI_SPECULARCOLOR;
	RtToken			*tRI_KR;
	RtToken			*tRI_TEXTURENAME;
	RtToken			*tRI_DEPTHCUE;
	RtToken			*tRI_FOG;
	RtToken			*tRI_BUMPY;
	RtToken			*tRI_MINDISTANCE;
	RtToken			*tRI_MAXDISTANCE;
	RtToken			*tRI_BACKGROUND;
	RtToken			*tRI_DISTANCE;
	RtToken			*tRI_AMPLITUDE;
	RtToken			*tRI_RASTER;
	RtToken			*tRI_SCREEN;
	RtToken			*tRI_CAMERA;
	RtToken			*tRI_WORLD;
	RtToken			*tRI_OBJECT;
	RtToken			*tRI_INSIDE;
	RtToken			*tRI_OUTSIDE;
	RtToken			*tRI_LH;
	RtToken			*tRI_RH;
	RtToken			*tRI_P;
	RtToken			*tRI_PZ;
	RtToken			*tRI_PW;
	RtToken			*tRI_N;
	RtToken			*tRI_NP;
	RtToken			*tRI_CS;
	RtToken			*tRI_OS;
	RtToken			*tRI_S;
	RtToken			*tRI_T;
	RtToken			*tRI_ST;
	RtToken			*tRI_BILINEAR;
	RtToken			*tRI_BICUBIC;
	RtToken			*tRI_PRIMITIVE;
	RtToken			*tRI_INTERSECTION;
	RtToken			*tRI_UNION;
	RtToken			*tRI_DIFFERENCE;
	RtToken			*tRI_PERIODIC;
	RtToken			*tRI_NONPERIODIC;
	RtToken			*tRI_CLAMP;
	RtToken			*tRI_BLACK;
	RtToken			*tRI_IGNORE;
	RtToken			*tRI_PRINT;
	RtToken			*tRI_ABORT;
	RtToken			*tRI_HANDLER;
	RtToken			*tRI_COMMENT;
	RtToken			*tRI_STRUCTURE;
	RtToken			*tRI_IDENTIFIER;
	RtToken			*tRI_NAME;
	RtToken			*tRI_SHADINGGROUP;
	
} RiComp_Tokens_Struct, *RiComp_Tokens_Ptr;
