#include "RiFace.h"

#if FACE
extern ComponentInstance sRiStandardFace_Inst;
#define FNAME(name)	name
#define INST_PARAM	
#define INST		sRiStandardFace_Inst
#else
#define FNAME(name) c##name
#define INST_PARAM	ComponentInstance ci,
#define INST ci
#include "RiFace_v.h"
#endif



/********** Stdarg -> V routines **********/


RtVoid FNAME(RiArchiveRecord)(INST_PARAM RtToken type, char *format, ...)
{
	va_list	vap;
	
	va_start(vap, format);
	cRiVArchiveRecord(INST, type, format, vap);
	va_end(vap);
}

RtVoid FNAME(RiMotionBegin)(INST_PARAM RtInt n, ...)
{
	va_list	vap;
	
	va_start(vap, n);
	cRiVMotionBegin(INST, n, vap);
	va_end(vap);
}

RtLightHandle FNAME(RiAreaLightSource)(INST_PARAM RtToken name, ...)
{
	va_list		vap;
	RtToken		*args;
	RtPointer	*data;
	RtInt		num;

	va_start(vap, name);
	num = ri_vectorize(vap, &args, &data);
	va_end(vap);

	cRiAreaLightSourceV(INST, name, num, args, data);
}

RtLightHandle FNAME(RiLightSource)(INST_PARAM RtToken name, ...)
{
	va_list		vap;
	RtToken		*args;
	RtPointer	*data;
	RtInt		num;

	va_start(vap, name);
	num = ri_vectorize(vap, &args, &data);
	va_end(vap);

	cRiLightSourceV(INST, name, num, args, data);
}

RtVoid FNAME(RiAtmosphere)(INST_PARAM RtToken name, ...)
{
	va_list		vap;
	RtToken		*args;
	RtPointer	*data;
	RtInt		num;

	va_start(vap, name);
	num = ri_vectorize(vap, &args, &data);
	va_end(vap);

	cRiAtmosphereV(INST, name, num, args, data);
}

RtVoid FNAME(RiAttribute)(INST_PARAM RtToken name, ...)
{
	va_list		vap;
	RtToken		*args;
	RtPointer	*data;
	RtInt		num;

	va_start(vap, name);
	num = ri_vectorize(vap, &args, &data);
	va_end(vap);

	cRiAttributeV(INST, name, num, args, data);
}

RtVoid FNAME(RiCone)(INST_PARAM RtFloat height, RtFloat radius, RtFloat tmax, ...)
{
	va_list		vap;
	RtToken		*args;
	RtPointer	*data;
	RtInt		num;

	va_start(vap, tmax);
	num = ri_vectorize(vap, &args, &data);
	va_end(vap);

	cRiConeV(INST, height, radius, tmax, num, args, data);
}

RtVoid FNAME(RiCylinder)(INST_PARAM RtFloat radius, RtFloat zmin, RtFloat zmax, RtFloat tmax, ...)
{
	va_list		vap;
	RtToken		*args;
	RtPointer	*data;
	RtInt		num;

	va_start(vap, tmax);
	num = ri_vectorize(vap, &args, &data);
	va_end(vap);

	cRiCylinderV(INST, radius, zmin, zmax, tmax, num, args, data);
}

RtVoid FNAME(RiDeformation)(INST_PARAM RtToken name, ...)
{
	va_list		vap;
	RtToken		*args;
	RtPointer	*data;
	RtInt		num;

	va_start(vap, name);
	num = ri_vectorize(vap, &args, &data);
	va_end(vap);

	cRiDeformationV(INST, name, num, args, data);
}

RtVoid FNAME(RiDisk)(INST_PARAM RtFloat height, RtFloat radius, RtFloat tmax, ...)
{
	va_list		vap;
	RtToken		*args;
	RtPointer	*data;
	RtInt		num;

	va_start(vap, tmax);
	num = ri_vectorize(vap, &args, &data);
	va_end(vap);

	cRiDiskV(INST, height, radius, tmax, num, args, data);
}

RtVoid FNAME(RiDisplacement)(INST_PARAM RtToken name, ...)
{
	va_list		vap;
	RtToken		*args;
	RtPointer	*data;
	RtInt		num;

	va_start(vap, name);
	num = ri_vectorize(vap, &args, &data);
	va_end(vap);

	cRiDisplacementV(INST, name, num, args, data);
}

RtVoid FNAME(RiDisplay)(INST_PARAM char *name, RtToken type, RtToken mode, ...)
{
	va_list		vap;
	RtToken		*args;
	RtPointer	*data;
	RtInt		num;

	va_start(vap, mode);
	num = ri_vectorize(vap, &args, &data);
	va_end(vap);

	cRiDisplayV(INST, name, type, mode, num, args, data);
}

RtVoid FNAME(RiExterior)(INST_PARAM RtToken name, ...)
{
	va_list		vap;
	RtToken		*args;
	RtPointer	*data;
	RtInt		num;

	va_start(vap, name);
	num = ri_vectorize(vap, &args, &data);
	va_end(vap);

	cRiExteriorV(INST, name, num, args, data);
}

RtVoid FNAME(RiGeneralPolygon)(INST_PARAM RtInt nloops, RtInt nverts[], ...)
{
	va_list		vap;
	RtToken		*args;
	RtPointer	*data;
	RtInt		num;

	va_start(vap, nverts);
	num = ri_vectorize(vap, &args, &data);
	va_end(vap);

	cRiGeneralPolygonV(INST, nloops, nverts, num, args, data);
}

RtVoid FNAME(RiGeometry)(INST_PARAM RtToken type, ...)
{
	va_list		vap;
	RtToken		*args;
	RtPointer	*data;
	RtInt		num;

	va_start(vap, type);
	num = ri_vectorize(vap, &args, &data);
	va_end(vap);

	cRiGeometryV(INST, type, num, args, data);
}

RtVoid FNAME(RiHider)(INST_PARAM RtToken type, ...)
{
	va_list		vap;
	RtToken		*args;
	RtPointer	*data;
	RtInt		num;

	va_start(vap, type);
	num = ri_vectorize(vap, &args, &data);
	va_end(vap);

	cRiHiderV(INST, type, num, args, data);
}

RtVoid FNAME(RiHyperboloid)(INST_PARAM RtPoint point1, RtPoint point2, RtFloat tmax, ...)
{
	va_list		vap;
	RtToken		*args;
	RtPointer	*data;
	RtInt		num;

	va_start(vap, tmax);
	num = ri_vectorize(vap, &args, &data);
	va_end(vap);

	cRiHyperboloidV(INST, point1, point2, tmax, num, args, data);
}

RtVoid FNAME(RiImager)(INST_PARAM RtToken name, ...)
{
	va_list		vap;
	RtToken		*args;
	RtPointer	*data;
	RtInt		num;

	va_start(vap, name);
	num = ri_vectorize(vap, &args, &data);
	va_end(vap);

	cRiImagerV(INST, name, num, args, data);
}

RtVoid FNAME(RiInterior)(INST_PARAM RtToken name, ...)
{
	va_list		vap;
	RtToken		*args;
	RtPointer	*data;
	RtInt		num;

	va_start(vap, name);
	num = ri_vectorize(vap, &args, &data);
	va_end(vap);

	cRiInteriorV(INST, name, num, args, data);
}

RtVoid FNAME(RiMakeBump)(INST_PARAM char *pic, char *tex, RtToken swrap, RtToken twrap, RtFilterFunc filterfunc, RtFloat swidth, RtFloat twidth, ...)
{
	va_list		vap;
	RtToken		*args;
	RtPointer	*data;
	RtInt		num;

	va_start(vap, twidth);
	num = ri_vectorize(vap, &args, &data);
	va_end(vap);

	cRiMakeBumpV(INST, pic, tex, swrap, twrap, filterfunc, swidth, twidth, num, args, data);
}

RtVoid FNAME(RiMakeCubeFaceEnvironment)(INST_PARAM char *px, char *nx, char *py, char *ny, char *pz, char *nz, char *tex, RtFloat fov, RtFilterFunc filterfunc, RtFloat swidth, RtFloat ywidth, ...)
{
	va_list		vap;
	RtToken		*args;
	RtPointer	*data;
	RtInt		num;

	va_start(vap, ywidth);
	num = ri_vectorize(vap, &args, &data);
	va_end(vap);

	cRiMakeCubeFaceEnvironmentV(INST, px, nx, py, ny, pz, nz, tex, fov, filterfunc, swidth, ywidth, num, args, data);
}

RtVoid FNAME(RiMakeLatLongEnvironment)(INST_PARAM char *pic, char *tex, RtFilterFunc filterfunc, RtFloat swidth, RtFloat twidth, ...)
{
	va_list		vap;
	RtToken		*args;
	RtPointer	*data;
	RtInt		num;

	va_start(vap, twidth);
	num = ri_vectorize(vap, &args, &data);
	va_end(vap);

	cRiMakeLatLongEnvironmentV(INST, pic, tex, filterfunc, swidth, twidth, num, args, data);
}

RtVoid FNAME(RiMakeShadow)(INST_PARAM char *pic, char *tex, ...)
{
	va_list		vap;
	RtToken		*args;
	RtPointer	*data;
	RtInt		num;

	va_start(vap, tex);
	num = ri_vectorize(vap, &args, &data);
	va_end(vap);

	cRiMakeShadowV(INST, pic, tex, num, args, data);
}

RtVoid FNAME(RiMakeTexture)(INST_PARAM char *pic, char *tex, RtToken swrap, RtToken twrap, RtFilterFunc filterfunc, RtFloat swidth, RtFloat twidth, ...)
{
	va_list		vap;
	RtToken		*args;
	RtPointer	*data;
	RtInt		num;

	va_start(vap, twidth);
	num = ri_vectorize(vap, &args, &data);
	va_end(vap);

	cRiMakeTextureV(INST, pic, tex, swrap, twrap, filterfunc, swidth, twidth, num, args, data);
}

RtVoid FNAME(RiNuPatch)(INST_PARAM RtInt nu, RtInt uorder, RtFloat uknot[], RtFloat umin, RtFloat umax, RtInt nv, RtInt vorder, RtFloat vknot[], RtFloat vmin, RtFloat vmax, ...)
{
	va_list		vap;
	RtToken		*args;
	RtPointer	*data;
	RtInt		num;

	va_start(vap, vmax);
	num = ri_vectorize(vap, &args, &data);
	va_end(vap);

	cRiNuPatchV(INST, nu, uorder, uknot, umin, umax, nv, vorder, vknot, vmin, vmax, num, args, data);
}

RtVoid FNAME(RiOption)(INST_PARAM RtToken name, ...)
{
	va_list		vap;
	RtToken		*args;
	RtPointer	*data;
	RtInt		num;

	va_start(vap, name);
	num = ri_vectorize(vap, &args, &data);
	va_end(vap);

	cRiOptionV(INST, name, num, args, data);
}

RtVoid FNAME(RiParaboloid)(INST_PARAM RtFloat rmax, RtFloat zmin, RtFloat zmax, RtFloat tmax, ...)
{
	va_list		vap;
	RtToken		*args;
	RtPointer	*data;
	RtInt		num;

	va_start(vap, tmax);
	num = ri_vectorize(vap, &args, &data);
	va_end(vap);

	cRiParaboloidV(INST, rmax, zmin, zmax, tmax, num, args, data);
}

RtVoid FNAME(RiPatch)(INST_PARAM RtToken type, ...)
{
	va_list		vap;
	RtToken		*args;
	RtPointer	*data;
	RtInt		num;

	va_start(vap, type);
	num = ri_vectorize(vap, &args, &data);
	va_end(vap);

	cRiPatchV(INST, type, num, args, data);
}

RtVoid FNAME(RiPatchMesh)(INST_PARAM RtToken type, RtInt nu, RtToken uwrap, RtInt nv, RtToken vwrap, ...)
{
	va_list		vap;
	RtToken		*args;
	RtPointer	*data;
	RtInt		num;

	va_start(vap, vwrap);
	num = ri_vectorize(vap, &args, &data);
	va_end(vap);

	cRiPatchMeshV(INST, type, nu, uwrap, nv, vwrap, num, args, data);
}

RtVoid FNAME(RiPointsGeneralPolygons)(INST_PARAM RtInt npolys, RtInt nloops[], RtInt nverts[], RtInt verts[], ...)
{
	va_list		vap;
	RtToken		*args;
	RtPointer	*data;
	RtInt		num;

	va_start(vap, verts);
	num = ri_vectorize(vap, &args, &data);
	va_end(vap);

	cRiPointsGeneralPolygonsV(INST, npolys, nloops, nverts, verts, num, args, data);
}

RtVoid FNAME(RiPointsPolygons)(INST_PARAM RtInt npolys, RtInt nverts[], RtInt verts[], ...)
{
	va_list		vap;
	RtToken		*args;
	RtPointer	*data;
	RtInt		num;

	va_start(vap, verts);
	num = ri_vectorize(vap, &args, &data);
	va_end(vap);

	cRiPointsPolygonsV(INST, npolys, nverts, verts, num, args, data);
}

RtVoid FNAME(RiPolygon)(INST_PARAM RtInt nverts, ...)
{
	va_list		vap;
	RtToken		*args;
	RtPointer	*data;
	RtInt		num;

	va_start(vap, nverts);
	num = ri_vectorize(vap, &args, &data);
	va_end(vap);

	cRiPolygonV(INST, nverts, num, args, data);
}

RtVoid FNAME(RiProjection)(INST_PARAM RtToken name, ...)
{
	va_list		vap;
	RtToken		*args;
	RtPointer	*data;
	RtInt		num;

	va_start(vap, name);
	num = ri_vectorize(vap, &args, &data);
	va_end(vap);

	cRiProjectionV(INST, name, num, args, data);
}

RtVoid FNAME(RiSphere)(INST_PARAM RtFloat radius, RtFloat zmin, RtFloat zmax, RtFloat tmax, ...)
{
	va_list		vap;
	RtToken		*args;
	RtPointer	*data;
	RtInt		num;

	va_start(vap, tmax);
	num = ri_vectorize(vap, &args, &data);
	va_end(vap);

	cRiSphereV(INST, radius, zmin, zmax, tmax, num, args, data);
}

RtVoid FNAME(RiSurface)(INST_PARAM RtToken name, ...)
{
	va_list		vap;
	RtToken		*args;
	RtPointer	*data;
	RtInt		num;

	va_start(vap, name);
	num = ri_vectorize(vap, &args, &data);
	va_end(vap);

	cRiSurfaceV(INST, name, num, args, data);
}

RtVoid FNAME(RiTorus)(INST_PARAM RtFloat majrad, RtFloat minrad, RtFloat phimin, RtFloat phimax, RtFloat tmax, ...)
{
	va_list		vap;
	RtToken		*args;
	RtPointer	*data;
	RtInt		num;

	va_start(vap, tmax);
	num = ri_vectorize(vap, &args, &data);
	va_end(vap);

	cRiTorusV(INST, majrad, minrad, phimin, phimax, tmax, num, args, data);
}

