#pragma once

#include <ri.h>
#include <Components.h>

RtVoid cRiArchiveRecord(ComponentInstance ci, RtToken type, char *format, ...);
RtVoid cRiMotionBegin(ComponentInstance ci, RtInt n, ...);

RtLightHandle cRiAreaLightSource(ComponentInstance ci, RtToken name, ...);
RtLightHandle cRiLightSource(ComponentInstance ci, RtToken name, ...);
RtVoid cRiAtmosphere(ComponentInstance ci, RtToken name, ...);
RtVoid cRiAttribute(ComponentInstance ci, RtToken name, ...);
RtVoid cRiCone(ComponentInstance ci, RtFloat height, RtFloat radius, RtFloat tmax, ...);
RtVoid cRiCylinder(ComponentInstance ci, RtFloat radius, RtFloat zmin, RtFloat zmax, RtFloat tmax, ...);
RtVoid cRiDeformation(ComponentInstance ci, RtToken name, ...);
RtVoid cRiDisk(ComponentInstance ci, RtFloat height, RtFloat radius, RtFloat tmax, ...);
RtVoid cRiDisplacement(ComponentInstance ci, RtToken name, ...);
RtVoid cRiDisplay(ComponentInstance ci, char *name, RtToken type, RtToken mode, ...);
RtVoid cRiExterior(ComponentInstance ci, RtToken name, ...);
RtVoid cRiGeneralPolygon(ComponentInstance ci, RtInt nloops, RtInt nverts[], ...);
RtVoid cRiGeometry(ComponentInstance ci, RtToken type, ...);
RtVoid cRiHider(ComponentInstance ci, RtToken type, ...);
RtVoid cRiHyperboloid(ComponentInstance ci, RtPoint point1, RtPoint point2, RtFloat tmax, ...);
RtVoid cRiImager(ComponentInstance ci, RtToken name, ...);
RtVoid cRiInterior(ComponentInstance ci, RtToken name, ...);
RtVoid cRiMakeBump(ComponentInstance ci, char *pic, char *tex, RtToken swrap, RtToken twrap, RtFilterFunc filterfunc, RtFloat swidth, RtFloat twidth, ...);
RtVoid cRiMakeCubeFaceEnvironment(ComponentInstance ci, char *px, char *nx, char *py, char *ny, char *pz, char *nz, char *tex, RtFloat fov, RtFilterFunc filterfunc, RtFloat swidth, RtFloat ywidth, ...);
RtVoid cRiMakeLatLongEnvironment(ComponentInstance ci, char *pic, char *tex, RtFilterFunc filterfunc, RtFloat swidth, RtFloat twidth, ...);
RtVoid cRiMakeShadow(ComponentInstance ci, char *pic, char *tex, ...);
RtVoid cRiMakeTexture(ComponentInstance ci, char *pic, char *tex, RtToken swrap, RtToken twrap, RtFilterFunc filterfunc, RtFloat swidth, RtFloat twidth, ...);
RtVoid cRiNuPatch(ComponentInstance ci, RtInt nu, RtInt uorder, RtFloat uknot[], RtFloat umin, RtFloat umax, RtInt nv, RtInt vorder, RtFloat vknot[], RtFloat vmin, RtFloat vmax, ...);
RtVoid cRiOption(ComponentInstance ci, RtToken name, ...);
RtVoid cRiParaboloid(ComponentInstance ci, RtFloat rmax, RtFloat zmin, RtFloat zmax, RtFloat tmax, ...);
RtVoid cRiPatch(ComponentInstance ci, RtToken type, ...);
RtVoid cRiPatchMesh(ComponentInstance ci, RtToken type, RtInt nu, RtToken uwrap, RtInt nv, RtToken vwrap, ...);
RtVoid cRiPointsGeneralPolygons(ComponentInstance ci, RtInt npolys, RtInt nloops[], RtInt nverts[], RtInt verts[], ...);
RtVoid cRiPointsPolygons(ComponentInstance ci, RtInt npolys, RtInt nverts[], RtInt verts[], ...);
RtVoid cRiPolygon(ComponentInstance ci, RtInt nverts, ...);
RtVoid cRiProjection(ComponentInstance ci, RtToken name, ...);
RtVoid cRiSphere(ComponentInstance ci, RtFloat radius, RtFloat zmin, RtFloat zmax, RtFloat tmax, ...);
RtVoid cRiSurface(ComponentInstance ci, RtToken name, ...);
RtVoid cRiTorus(ComponentInstance ci, RtFloat majrad, RtFloat minrad, RtFloat phimin, RtFloat phimax, RtFloat tmax, ...);
