#pragma once

#include <ri.h>
#include <Components.h>
#include <RiFace_common.h>
#include <RiFace.h>

extern ComponentInstance 				sRiStandardFace_Inst;
extern RiComp_Tokens_Ptr				sRiStandardFace_Tokens;

#define RiBezierBasis					(*sRiStandardFace_Tokens->tRiBezierBasis)
#define RiBSplineBasis					(*sRiStandardFace_Tokens->tRiBSplineBasis)
#define RiCatmullRomBasis				(*sRiStandardFace_Tokens->tRiCatmullRomBasis)
#define RiHermiteBasis					(*sRiStandardFace_Tokens->tRiHermiteBasis)
#define RiPowerBasis					(*sRiStandardFace_Tokens->tRiPowerBasis)

#define RiGaussianFilter				(sRiStandardFace_Tokens->tRiGaussianFilter)
#define RiBoxFilter						(sRiStandardFace_Tokens->tRiBoxFilter)
#define RiTriangleFilter				(sRiStandardFace_Tokens->tRiTriangleFilter)
#define RiCatmullRomFilter				(sRiStandardFace_Tokens->tRiCatmullRomFilter)
#define RiSincFilter					(sRiStandardFace_Tokens->tRiSincFilter)
#define RiBesselFilter					(sRiStandardFace_Tokens->tRiBesselFilter)

#define RiLastError						(sRiStandardFace_Tokens->*tRiLastError)

#define RiErrorIgnore					(sRiStandardFace_Tokens->tRiErrorIgnore)
#define RiErrorPrint					(sRiStandardFace_Tokens->tRiErrorPrint)
#define RiErrorAbort					(sRiStandardFace_Tokens->tRiErrorAbort)

#define RI_FRAMEBUFFER 					(*sRiStandardFace_Tokens->tRI_FRAMEBUFFER)
#define RI_FILE 						(*sRiStandardFace_Tokens->tRI_FILE)
#define RI_RGB 							(*sRiStandardFace_Tokens->tRI_RGB)
#define RI_RGBA 						(*sRiStandardFace_Tokens->tRI_RGBA)
#define RI_RGBZ 						(*sRiStandardFace_Tokens->tRI_RGBZ)
#define RI_RGBAZ 						(*sRiStandardFace_Tokens->tRI_RGBAZ)
#define RI_A 							(*sRiStandardFace_Tokens->tRI_A)
#define RI_Z 							(*sRiStandardFace_Tokens->tRI_Z)
#define RI_AZ 							(*sRiStandardFace_Tokens->tRI_AZ)
#define RI_PERSPECTIVE 					(*sRiStandardFace_Tokens->tRI_PERSPECTIVE)
#define RI_ORTHOGRAPHIC 				(*sRiStandardFace_Tokens->tRI_ORTHOGRAPHIC)
#define RI_HIDDEN 						(*sRiStandardFace_Tokens->tRI_HIDDEN)
#define RI_PAINT 						(*sRiStandardFace_Tokens->tRI_PAINT)
#define RI_CONSTANT 					(*sRiStandardFace_Tokens->tRI_CONSTANT)
#define RI_SMOOTH 						(*sRiStandardFace_Tokens->tRI_SMOOTH)
#define RI_ORIGIN 						(*sRiStandardFace_Tokens->tRI_ORIGIN)
#define RI_FLATNESS 					(*sRiStandardFace_Tokens->tRI_FLATNESS)
#define RI_MOTIONFACTOR 				(*sRiStandardFace_Tokens->tRI_MOTIONFACTOR)
#define RI_TRIMDEVIATION 				(*sRiStandardFace_Tokens->tRI_TRIMDEVIATION)
#define RI_FOV 							(*sRiStandardFace_Tokens->tRI_FOV)
#define RI_AMBIENTLIGHT 				(*sRiStandardFace_Tokens->tRI_AMBIENTLIGHT)
#define RI_POINTLIGHT 					(*sRiStandardFace_Tokens->tRI_POINTLIGHT)
#define RI_DISTANTLIGHT 				(*sRiStandardFace_Tokens->tRI_DISTANTLIGHT)
#define RI_SPOTLIGHT 					(*sRiStandardFace_Tokens->tRI_SPOTLIGHT)
#define RI_INTENSITY 					(*sRiStandardFace_Tokens->tRI_INTENSITY)
#define RI_LIGHTCOLOR 					(*sRiStandardFace_Tokens->tRI_LIGHTCOLOR)
#define RI_FROM 						(*sRiStandardFace_Tokens->tRI_FROM)
#define RI_TO 							(*sRiStandardFace_Tokens->tRI_TO)
#define RI_CONEANGLE 					(*sRiStandardFace_Tokens->tRI_CONEANGLE)
#define RI_CONEDELTAANGLE 				(*sRiStandardFace_Tokens->tRI_CONEDELTAANGLE)
#define RI_BEAMDISTRIBUTION 			(*sRiStandardFace_Tokens->tRI_BEAMDISTRIBUTION)
#define RI_MATTE 						(*sRiStandardFace_Tokens->tRI_MATTE)
#define RI_METAL 						(*sRiStandardFace_Tokens->tRI_METAL)
#define RI_SHINYMETAL 					(*sRiStandardFace_Tokens->tRI_SHINYMETAL)
#define RI_PLASTIC 						(*sRiStandardFace_Tokens->tRI_PLASTIC)
#define RI_PAINTEDPLASTIC 				(*sRiStandardFace_Tokens->tRI_PAINTEDPLASTIC)
#define RI_KA 							(*sRiStandardFace_Tokens->tRI_KA)
#define RI_KD 							(*sRiStandardFace_Tokens->tRI_KD)
#define RI_KS 							(*sRiStandardFace_Tokens->tRI_KS)
#define RI_ROUGHNESS 					(*sRiStandardFace_Tokens->tRI_ROUGHNESS)
#define RI_SPECULARCOLOR 				(*sRiStandardFace_Tokens->tRI_SPECULARCOLOR)
#define RI_KR 							(*sRiStandardFace_Tokens->tRI_KR)
#define RI_TEXTURENAME 					(*sRiStandardFace_Tokens->tRI_TEXTURENAME)
#define RI_DEPTHCUE 					(*sRiStandardFace_Tokens->tRI_DEPTHCUE)
#define RI_FOG 							(*sRiStandardFace_Tokens->tRI_FOG)
#define RI_BUMPY 						(*sRiStandardFace_Tokens->tRI_BUMPY)
#define RI_MINDISTANCE 					(*sRiStandardFace_Tokens->tRI_MINDISTANCE)
#define RI_MAXDISTANCE 					(*sRiStandardFace_Tokens->tRI_MAXDISTANCE)
#define RI_BACKGROUND 					(*sRiStandardFace_Tokens->tRI_BACKGROUND)
#define RI_DISTANCE 					(*sRiStandardFace_Tokens->tRI_DISTANCE)
#define RI_AMPLITUDE 					(*sRiStandardFace_Tokens->tRI_AMPLITUDE)
#define RI_RASTER 						(*sRiStandardFace_Tokens->tRI_RASTER)
#define RI_SCREEN 						(*sRiStandardFace_Tokens->tRI_SCREEN)
#define RI_CAMERA 						(*sRiStandardFace_Tokens->tRI_CAMERA)
#define RI_WORLD 						(*sRiStandardFace_Tokens->tRI_WORLD)
#define RI_OBJECT 						(*sRiStandardFace_Tokens->tRI_OBJECT)
#define RI_INSIDE 						(*sRiStandardFace_Tokens->tRI_INSIDE)
#define RI_OUTSIDE 						(*sRiStandardFace_Tokens->tRI_OUTSIDE)
#define RI_LH 							(*sRiStandardFace_Tokens->tRI_LH)
#define RI_RH 							(*sRiStandardFace_Tokens->tRI_RH)
#define RI_P 							(*sRiStandardFace_Tokens->tRI_P)
#define RI_PZ 							(*sRiStandardFace_Tokens->tRI_PZ)
#define RI_PW 							(*sRiStandardFace_Tokens->tRI_PW)
#define RI_N 							(*sRiStandardFace_Tokens->tRI_N)
#define RI_NP 							(*sRiStandardFace_Tokens->tRI_NP)
#define RI_CS 							(*sRiStandardFace_Tokens->tRI_CS)
#define RI_OS 							(*sRiStandardFace_Tokens->tRI_OS)
#define RI_S 							(*sRiStandardFace_Tokens->tRI_S)
#define RI_T 							(*sRiStandardFace_Tokens->tRI_T)
#define RI_ST 							(*sRiStandardFace_Tokens->tRI_ST)
#define RI_BILINEAR 					(*sRiStandardFace_Tokens->tRI_BILINEAR)
#define RI_BICUBIC 						(*sRiStandardFace_Tokens->tRI_BICUBIC)
#define RI_PRIMITIVE 					(*sRiStandardFace_Tokens->tRI_PRIMITIVE)
#define RI_INTERSECTION 				(*sRiStandardFace_Tokens->tRI_INTERSECTION)
#define RI_UNION 						(*sRiStandardFace_Tokens->tRI_UNION)
#define RI_DIFFERENCE 					(*sRiStandardFace_Tokens->tRI_DIFFERENCE)
#define RI_PERIODIC 					(*sRiStandardFace_Tokens->tRI_PERIODIC)
#define RI_NONPERIODIC 					(*sRiStandardFace_Tokens->tRI_NONPERIODIC)
#define RI_CLAMP 						(*sRiStandardFace_Tokens->tRI_CLAMP)
#define RI_BLACK 						(*sRiStandardFace_Tokens->tRI_BLACK)
#define RI_IGNORE 						(*sRiStandardFace_Tokens->tRI_IGNORE)
#define RI_PRINT 						(*sRiStandardFace_Tokens->tRI_PRINT)
#define RI_ABORT 						(*sRiStandardFace_Tokens->tRI_ABORT)
#define RI_HANDLER 						(*sRiStandardFace_Tokens->tRI_HANDLER)
#define RI_COMMENT 						(*sRiStandardFace_Tokens->tRI_COMMENT)
#define RI_STRUCTURE 					(*sRiStandardFace_Tokens->tRI_STRUCTURE)
#define RI_IDENTIFIER 					(*sRiStandardFace_Tokens->tRI_IDENTIFIER)
#define RI_NAME 						(*sRiStandardFace_Tokens->tRI_NAME)
#define RI_SHADINGGROUP 				(*sRiStandardFace_Tokens->tRI_SHADINGGROUP)

#if 0
#define RiAttributeBegin()				cRiAttributeBegin(sRiStandardFace_Inst)
#define RiAttributeEnd()				cRiAttributeEnd(sRiStandardFace_Inst)
#define RiFrameBegin(frame)				cRiFrameBegin(sRiStandardFace_Inst, frame)
#define RiFrameEnd()					cRiFrameEnd(sRiStandardFace_Inst)
#define RiWorldBegin()					cRiWorldBegin(sRiStandardFace_Inst)
#define RiWorldEnd()					cRiWorldEnd(sRiStandardFace_Inst)
#define RiTransformBegin()				cRiTransformBegin(sRiStandardFace_Inst)
#define RiTransformEnd()				cRiTransformEnd(sRiStandardFace_Inst)
#define RiSolidBegin(operation)			cRiSolidBegin(sRiStandardFace_Inst, operation)
#define RiSolidEnd()					cRiSolidEnd(sRiStandardFace_Inst)
#define RiDeclare(name, declaration)	cRiDeclare(sRiStandardFace_Inst, name, declaration)
#define RiRotate(angle, dx, dy, dz)		cRiRotate(sRiStandardFace_Inst, angle, dx, dy, dz)
#define RiShadingRate(size)				cRiShadingRate(sRiStandardFace_Inst, size)
#define RiTranslate(dx, dy, dz)			cRiTranslate(sRiStandardFace_Inst, dx, dy, dz)
#define RiClipping(hither, yon)			cRiClipping(sRiStandardFace_Inst, hither, yon)
#define RiTransform(transform)			cRiTransform(sRiStandardFace_Inst, transform)
#define RiErrorHandler(handler)			cRiErrorHandler(sRiStandardFace_Inst, handler)
#define RiColorSamples(n, nRGB, RGBn)	cRiColorSamples(sRiStandardFace_Inst, n, nRGB, RGBn)
#define RiColor(color)					cRiColor(sRiStandardFace_Inst, color)
#define RiOpacity(color)				cRiOpacity(sRiStandardFace_Inst, color)
#define RiScale(x,y,z)					cRiScale(sRiStandardFace_Inst, x, y, z)
#define RiEnd()							cRiEnd(sRiStandardFace_Inst)
#endif

/*>	\([A-Za-z0-9_]*\)(\(.*\)),<*/
/*>#define \1(\2)		((RtVoid)c\1(sRiStandardFace_Inst, \2))<*/

#define RiDeclare(name, decl)			((RtToken)cRiDeclare(sRiStandardFace_Inst, name, decl))

#define RiFrameBegin(frame)				((RtVoid)cRiFrameBegin(sRiStandardFace_Inst, frame))
#define RiFrameEnd()					((RtVoid)cRiFrameEnd(sRiStandardFace_Inst))
#define RiWorldBegin()					((RtVoid)cRiWorldBegin(sRiStandardFace_Inst))
#define RiWorldEnd()					((RtVoid)cRiWorldEnd(sRiStandardFace_Inst))

#define RiFormat(xres, yres, aspect)			((RtVoid)cRiFormat(sRiStandardFace_Inst, xres, yres, aspect))
#define RiFrameAspectRatio(aspect)				((RtVoid)cRiFrameAspectRatio(sRiStandardFace_Inst, aspect))
#define RiScreenWindow(left, right, top, bot)	((RtVoid)cRiScreenWindow(sRiStandardFace_Inst, left, right, top, bot))
#define RiCropWindow(xmin, xmax, ymin, ymax)	((RtVoid)cRiCropWindow(sRiStandardFace_Inst, xmin, xmax, ymin, ymax))
#define RiProjectionV(name, n, tokens, parms)	((RtVoid)cRiProjectionV(sRiStandardFace_Inst, name, n, tokens, parms))
#define RiClipping(hither, yon)					((RtVoid)cRiClipping(sRiStandardFace_Inst, hither, yon))
#define RiDepthOfField(fstop, focallength, focaldistance)	\
												((RtVoid)cRiDepthOfField(sRiStandardFace_Inst, fstop, focallength, focaldistance))
#define RiShutter(min, max)						((RtVoid)cRiShutter(sRiStandardFace_Inst, min, max))

#define RiPixelVariance(variation)				((RtVoid)cRiPixelVariance(sRiStandardFace_Inst, variation))
#define RiPixelFidelity(variation)				((RtVoid)cRiPixelFidelity(sRiStandardFace_Inst, variation))
#define RiPixelSamples(xsamples, ysamples)		((RtVoid)cRiPixelSamples(sRiStandardFace_Inst, xsamples, ysamples))
#define RiPixelFilter(filterfunc, xwidth, ywidth) \
												((RtVoid)cRiPixelFilter(sRiStandardFace_Inst, filterfunc, xwidth, ywidth))
#define RiExposure(gain, gamma)					((RtVoid)cRiExposure(sRiStandardFace_Inst, gain, gamma))
#define RiImagerV(name, n, tokens, parms)		((RtVoid)cRiImagerV(sRiStandardFace_Inst, RtToken name, n, tokens, parms))
#define RiQuantize(type, one, min, max, ampl)	((RtVoid)cRiQuantize(sRiStandardFace_Inst, type, one, min, max, ampl))
#define RiDisplayV(name, type, mode, n, tokens, parms) \
												((RtVoid)cRiDisplayV(sRiStandardFace_Inst, name, type, mode, n, tokens, parms))

#define RiHiderV(type, n, tokens, parms)		((RtVoid)cRiHiderV(sRiStandardFace_Inst, type, n, tokens, parms))
#define RiColorSamples(n, nRGB, RGBn)			((RtVoid)cRiColorSamples(sRiStandardFace_Inst, n, nRGB, RGBn))
#define RiRelativeDetail(relativedetail)		((RtVoid)cRiRelativeDetail(sRiStandardFace_Inst, relativedetail))
#define RiOptionV(name, n, tokens, parms)		((RtVoid)cRiOptionV(sRiStandardFace_Inst, name, n, tokens, parms))

#define RiAttributeBegin(void)					((RtVoid)cRiAttributeBegin(sRiStandardFace_Inst))
#define RiAttributeEnd(void)					((RtVoid)cRiAttributeEnd(sRiStandardFace_Inst))
#define RiColor(color)							((RtVoid)cRiColor(sRiStandardFace_Inst, color))
#define RiOpacity(color)						((RtVoid)cRiOpacity(sRiStandardFace_Inst, color))
#define RiTextureCoordinates(s1, t1, s2, t2, s3, t3, s4, t4) \
												((RtVoid)cRiTextureCoordinates(sRiStandardFace_Inst, s1, t1, s2, t2, s3, t3, s4, t4))

#define RiLightSourceV(name, n, tokens, params) \
												((RtLightHandle)cRiLightSourceV(sRiStandardFace_Inst, name, n, tokens, params))
#define RiAreaLightSourceV(name, n, tokens, params) \
												((RtLightHandle)cRiAreaLightSourceV(sRiStandardFace_Inst, name, n, tokens, params))
	
#define RiIlluminate(light, onoff)				((RtVoid)cRiIlluminate(sRiStandardFace_Inst, light, onoff))
#define RiSurfaceV(name, n, tokens, params)		((RtVoid)cRiSurfaceV(sRiStandardFace_Inst, name, n, tokens, params))
#define RiAtmosphereV(name, n, tokens, params)	((RtVoid)cRiAtmosphereV(sRiStandardFace_Inst, name, n, tokens, params))
#define RiInteriorV(name, n, tokens, params)	((RtVoid)cRiInteriorV(sRiStandardFace_Inst, name, n, tokens, params))
#define RiExteriorV(name, n, tokens, params)	((RtVoid)cRiExteriorV(sRiStandardFace_Inst, name, n, tokens, params))
#define RiShadingRate(size)						((RtVoid)cRiShadingRate(sRiStandardFace_Inst, size))
#define RiShadingInterpolation(type)			((RtVoid)cRiShadingInterpolation(sRiStandardFace_Inst, type))
#define RiMatte(onoff)							((RtVoid)cRiMatte(sRiStandardFace_Inst, onoff))

#define RiBound(bound)							((RtVoid)cRiBound(sRiStandardFace_Inst, bound))
#define RiDetail(bound)							((RtVoid)cRiDetail(sRiStandardFace_Inst, bound))
#define RiDetailRange(minvis, lowtran, uptran, maxvis) \
												((RtVoid)cRiDetailRange(sRiStandardFace_Inst, minvis, lowtran, uptran, maxvis))
#define RiGeometricApproximation(type, value)	((RtVoid)cRiGeometricApproximation(sRiStandardFace_Inst, type, value))
#define RiOrientation(orientation)				((RtVoid)cRiOrientation(sRiStandardFace_Inst, orientation))
#define RiReverseOrientation(void)				((RtVoid)cRiReverseOrientation(sRiStandardFace_Inst))
#define RiSides(sides)							((RtVoid)cRiSides(sRiStandardFace_Inst, sides))

#define RiIdentity(void)						((RtVoid)cRiIdentity(sRiStandardFace_Inst))
#define RiTransform(transform)					((RtVoid)cRiTransform(sRiStandardFace_Inst, transform))
#define RiConcatTransform(transform)			((RtVoid)cRiConcatTransform(sRiStandardFace_Inst, transform))
#define RiPerspective(fov)						((RtVoid)cRiPerspective(sRiStandardFace_Inst, fov))
#define RiTranslate(dx, dy, dz)					((RtVoid)cRiTranslate(sRiStandardFace_Inst, dx, dy, dz))
#define RiRotate(angle, dx, dy, dz)				((RtVoid)cRiRotate(sRiStandardFace_Inst, angle, dx, dy, dz))
#define RiScale(sx, sy, sz)						((RtVoid)cRiScale(sRiStandardFace_Inst, sx, sy, sz))
#define RiSkew(angle, dx1, dy1, dz1, dx2, dy2, dz2) \
												((RtVoid)cRiSkew(sRiStandardFace_Inst, angle, dx1, dy1, dz1, dx2, dy2, dz2))
#define RiDeformationV(name, n, tokens, params) \
												((RtVoid)cRiDeformationV(sRiStandardFace_Inst, name, n, tokens, params))
#define RiDisplacementV(name, n, tokens, params) \
												((RtVoid)cRiDisplacementV(sRiStandardFace_Inst, name, n, tokens, params))
#define RiCoordinateSystem(space)				((RtVoid)cRiCoordinateSystem(sRiStandardFace_Inst, space))
	
#define RiTransformPoints(fromspace, tospace, n, points) \
												((RtPoint *)cRiTransformPoints(sRiStandardFace_Inst, fromspace, tospace, n, points))
	
#define RiTransformBegin(void)					((RtVoid)cRiTransformBegin(sRiStandardFace_Inst))
#define RiTransformEnd(void)					((RtVoid)cRiTransformEnd(sRiStandardFace_Inst))

#define RiAttributeV(name, n, tokens, params)	((RtVoid)cRiAttributeV(sRiStandardFace_Inst, name, n, tokens, params))

#define RiPolygonV(nverts, n, tokens, params) \
												((RtVoid)cRiPolygonV(sRiStandardFace_Inst, nverts, n, tokens, params))
#define RiGeneralPolygonV(nloops, nverts, n, tokens, params) \
												((RtVoid)cRiGeneralPolygonV(sRiStandardFace_Inst, nloops, nverts, n, tokens, params))
#define RiPointsPolygonsV(npolys, nverts, verts, n, tokens, params)	 \
												((RtVoid)cRiPointsPolygonsV(sRiStandardFace_Inst, npolys, nverts, verts, n, tokens, params))
#define RiPointsGeneralPolygonsV(npolys, nloops, nverts, verts, n, tokens, params) \
												((RtVoid)cRiPointsGeneralPolygonsV(sRiStandardFace_Inst, npolys, nloops, nverts, verts, n, tokens, params))
#define RiBasis(ubasis, ustep, vbasis, vstep)	((RtVoid)cRiBasis(sRiStandardFace_Inst, ubasis, ustep, vbasis, vstep))
#define RiPatchV(type, n, tokens, params)		((RtVoid)cRiPatchV(sRiStandardFace_Inst, type, n, tokens, params))
#define RiPatchMeshV(type, nu, uwrap, nv, vwrap, n, tokens, params) \
												((RtVoid)cRiPatchMeshV(sRiStandardFace_Inst, type, nu, uwrap, nv, vwrap, n, tokens, params))
#define RiNuPatchV(nu, uorder, uknot, umin, umax, nv, vorder, vknot, vmin, vmax, n, tokens, params) \
												((RtVoid)cRiNuPatchV(sRiStandardFace_Inst, nu, uorder, uknot, umin, umax, nv, vorder, vknot, vmin, vmax, n, tokens, params))
#define RiTrimCurve(nloops, ncurves, order, knot, min, max, n, u, v, w) \
												((RtVoid)cRiTrimCurve(sRiStandardFace_Inst, nloops, ncurves, order, knot, min, max, n, u, v, w))

#define RiSphereV(radius, zmin, zmax, tmax, n, tokens, params) \
												((RtVoid)cRiSphereV(sRiStandardFace_Inst, radius, zmin, zmax, tmax, n, tokens, params))
#define RiConeV(height, radius, tmax, n, tokens, params) \
												((RtVoid)cRiConeV(sRiStandardFace_Inst, height, radius, tmax, n, tokens, params))
#define RiCylinderV(radius, zmin, zmax, tmax, n, tokens, params) \
												((RtVoid)cRiCylinderV(sRiStandardFace_Inst, radius, zmin, zmax, tmax, n, tokens, params))
#define RiHyperboloidV(point1, point2, tmax, n, tokens, params) \
												((RtVoid)cRiHyperboloidV(sRiStandardFace_Inst, point1, point2, tmax, n, tokens, params))
#define RiParaboloidV(rmax, zmin, zmax, tmax, n, tokens, params) \
												((RtVoid)cRiParaboloidV(sRiStandardFace_Inst, rmax, zmin, zmax, tmax, n, tokens, params))
#define RiDiskV(height, radius, tmax, n, tokens, params) \
												((RtVoid)cRiDiskV(sRiStandardFace_Inst, height, radius, tmax, n, tokens, params))
#define RiTorusV(majrad, minrad, phimin, phimax, tmax, n, tokens, params) \
												((RtVoid)cRiTorusV(sRiStandardFace_Inst, majrad, minrad, phimin, phimax, tmax, n, tokens, params))
#define RiProcedural(data, bound, subdivfunc, freefunc) \
												((RtVoid)cRiProcedural(sRiStandardFace_Inst, data, bound, subdivfunc, freefunc))
#define RiGeometryV(type, n, tokens, params)	((RtVoid)cRiGeometryV(sRiStandardFace_Inst, type, n, tokens, params))

#define RiSolidBegin(operation)					((RtVoid)cRiSolidBegin(sRiStandardFace_Inst, operation))
#define RiSolidEnd(void)						((RtVoid)cRiSolidEnd(sRiStandardFace_Inst))
	
#define RiObjectBegin(void)						((RtObjectHandle)cRiObjectBegin(sRiStandardFace_Inst))
	
#define RiObjectEnd(void)						((RtVoid)cRiObjectEnd(sRiStandardFace_Inst))
#define RiObjectInstance(handle)				((RtVoid)cRiObjectInstance(sRiStandardFace_Inst, handle))
#define RiMotionBeginV(n, times)				((RtVoid)cRiMotionBeginV(sRiStandardFace_Inst, n, times))
#define RiMotionEnd(void)						((RtVoid)cRiMotionEnd(sRiStandardFace_Inst))

#define RiMakeTextureV(pic, tex, swrap, twrap, filterfunc, swidth, twidth, n, tokens, params) \
												((RtVoid)cRiMakeTextureV(sRiStandardFace_Inst, pic, tex, swrap, twrap, filterfunc, swidth, twidth, n, tokens, params))
#define RiMakeBumpV(pic, tex, swrap, twrap, filterfunc, swidth, twidth, n, tokens, params) \
												((RtVoid)cRiMakeBumpV(sRiStandardFace_Inst, pic, tex, swrap, twrap, filterfunc, swidth, twidth, n, tokens, params))
#define RiMakeLatLongEnvironmentV(pic, tex, filterfunc, swidth, twidth, n, tokens, params) \
												((RtVoid)cRiMakeLatLongEnvironmentV(sRiStandardFace_Inst, pic, tex, filterfunc, swidth, twidth, n, tokens, params))
#define RiMakeCubeFaceEnvironmentV(px, nx, py, ny, pz, nz, tex, fov, filterfunc, swidth, ywidth, n, tokens, params) \
												((RtVoid)cRiMakeCubeFaceEnvironmentV(sRiStandardFace_Inst, px, nx, py, ny, pz, nz, tex, fov, filterfunc, swidth, ywidth, n, tokens, params
#define RiMakeShadowV(pic, tex, n, tokens, params) \
												((RtVoid)cRiMakeShadowV(sRiStandardFace_Inst, pic, tex, n, tokens, params))

#define RiErrorHandler(handler)					((RtVoid)cRiErrorHandler(sRiStandardFace_Inst, handler))

#define RiErrorMode(mode, handler)				((RtVoid)cRiErrorMode(sRiStandardFace_Inst, mode, handler))
