/*	rip_pid.h	1.6	91/12/20	*/

/*---------------------------------------------------------------------
 *
 * Copyright (c) 1988 Pixar.   All rights reserved.   This program
 * or documentation contains  proprietary confidential information
 * and trade secrets of Pixar.  Reverse engineering of object code
 * is prohibited.   Use of copyright  notice is precautionary  and
 * does not imply publication.
 *
 *                    RESTRICTED RIGHTS NOTICE
 *
 * Use,  duplication,  or disclosure by the Government is subject to
 * restrictions as set forth in subdivision (b)(3)(ii) of the Rights
 * in Technical Data and Computer Software clause at 252.227-7013.
 *
 * Pixar
 * 3240 Kerner Blvd.
 * San Rafael, CA  94901-4840
 *
 *---------------------------------------------------------------------
 */

#ifndef _RIP_PID_
#define	_RIP_PID_

#if !defined(applec) && !defined(THINK_C)
#include <sys/types.h>
#endif

#include "ri.h"

#ifndef NULL
#define NULL 0
#endif

/*
 * RIP Parameter Identifier.
 */
typedef	struct {
	RtToken	pid_name;		/* parameter name, e.g. "xyz" */
	RtToken	pid_info;		/* definition, e.g. "varying point" */
	unsigned short	pid_flags;
#define PID_TYPE	0xF		/* type bit-field mask */
#define PID_FLOAT	0x1		/* float-array definition */
#define PID_POINT	0x2		/* point-based definition */
#define	PID_COLOR	0x3		/* color-based definition */
#define PID_INTEGER	0x4		/* integer-array definition */
#define PID_STRING	0x5		/* string-array definition */
#define	PID_VARYING	0x10		/* varying/uniform variable */
#define	PID_VERTEX	0x20		/* varying vertex variable */
#define	PID_SENT	0x40		/* declaration output */
	unsigned short	pid_recsize;	/* number of floats in record */
} RIPPid;

#ifdef __STDC__
extern	RIPPid	*RIPDeclarePID(RtToken name, RtToken info);
extern	RIPPid	*RIPLookupPIDByName(RtToken name);
extern	RtToken RIPNewToken(char *name, int len);
#else
extern	RIPPid	*RIPDeclarePID();
extern	RIPPid	*RIPLookupPIDByName();
extern	RtToken RIPNewToken();
#endif

#endif /* _RIP_PID_ */
