/*	ripcodes.h	1.4	89/10/26	*/

/*---------------------------------------------------------------------
 *
 * Copyright (c) 1988 Pixar.   All rights reserved.   This program
 * or documentation contains  proprietary confidential information
 * and trade secrets of Pixar.  Reverse engineering of object code
 * is prohibited.   Use of copyright  notice is precautionary  and
 * does not imply publication.
 *
 *                    RESTRICTED RIGHTS NOTICE
 *
 * Use,  duplication,  or disclosure by the Government is subject to
 * restrictions as set forth in subdivision (b)(3)(ii) of the Rights
 * in Technical Data and Computer Software clause at 252.227-7013.
 *
 * Pixar
 * 3240 Kerner Blvd.
 * San Rafael, CA  94901-4840
 *
 *---------------------------------------------------------------------
 */

/*
 * RenderMan Interface Protocol Codes.
 */
#define RIPCODE_INT		0200	/* integer & fixed point numbers */
#define RIPCODE_SHORTSTRING	0220	/* strings <= 15 characters */
#define RIPCODE_STRING		0240	/* strings > 15 characters */
#define RIPCODE_IEEEFLOAT	0244	/* IEEE single precision number */
#define RIPCODE_IEEEDOUBLE	0245	/* IEEE double precision number */
#define RIPCODE_RICODE		0246	/* RI request code (below) */
/* 0247-0307 reserved */
#define	RIPCODE_ARRAY		0310	/* array of single precision floats */
#define	RIPCODE_DEFREQUEST	0314	/* define encoded request */
#define	RIPCODE_DEFSTRING	0315	/* define encoded string */
#define	RIPCODE_STRINGID	0317	/* encoded string */
/* 0321-0377 reserved */

/*
 * RenderMan Interface Request Codes (0246 prefix)
 */
#define	RIPCODE_AREALIGHT	1	/* arealight */
#define	RIPCODE_ATMOSPHERE	2	/* atmosphere */
#define	RIPCODE_ATTRIBUTE	3	/* attribute */
#define	RIPCODE_ATTRIBUTEBEGIN	4	/* attributebegin */
#define	RIPCODE_ATTRIBUTEEND	5	/* attributeend */
#define	RIPCODE_BASIS		6	/* basis */
#define	RIPCODE_BOUND		7	/* bound */
#define	RIPCODE_COLOR		8	/* color */
#define	RIPCODE_CONCAT		9	/* concat */
#define	RIPCODE_CONE		10	/* cone */
#define	RIPCODE_CYLINDER	11	/* cylinder */
#define	RIPCODE_DECLARE		12	/* declare */
#define	RIPCODE_DEFORMATION	13	/* deformation */
#define	RIPCODE_DETAIL		14	/* detail */
#define	RIPCODE_DISK		15	/* disk */
#define	RIPCODE_DISPLACEMENT	16	/* displacement */
#define	RIPCODE_EXTERIOR	17	/* exterior */
#define	RIPCODE_FRAMEBEGIN	18	/* framebegin */
#define	RIPCODE_FRAMEEND	19	/* frameend */
#define	RIPCODE_GPOLYGON	20	/* gpolygon */
#define	RIPCODE_HYPERBOLOID	21	/* hyperboloid */
#define	RIPCODE_IDENTITY	22	/* identity */
#define	RIPCODE_ILLUMINATE	23	/* illuminate */
#define	RIPCODE_INTERIOR	24	/* interior */
#define	RIPCODE_LIGHT		25	/* light */
#define	RIPCODE_MARK		26	/* mark */
#define	RIPCODE_MATTE		27	/* matte */
#define	RIPCODE_MOTIONBEGIN	28	/* motionbegin */
#define	RIPCODE_MOTIONEND	29	/* motionend */
#define	RIPCODE_NUPATCH		30	/* nupatch */
#define	RIPCODE_OBJECTBEGIN	31	/* objectbegin */
#define	RIPCODE_OBJECTEND	32	/* objectend */
#define	RIPCODE_INSTANCE	33	/* objectinstance */
#define	RIPCODE_OPACITY		34	/* opacity */
#define	RIPCODE_OPTION		35	/* option */
#define	RIPCODE_ORIENTATION	36	/* orientation */
#define	RIPCODE_PARABOLOID	37	/* paraboloid */
#define	RIPCODE_PATCH		38	/* patch */
#define	RIPCODE_PATCHMESH	39	/* patchmesh */
#define	RIPCODE_PERSPECTIVE	40	/* perspective */
#define	RIPCODE_POINTSPOLYGONS	41	/* pointspolygons */
#define	RIPCODE_POINTSGPOLYGONS	42	/* pointsgpolygons */
#define	RIPCODE_POLYGON		43	/* polygon */
#define	RIPCODE_PROJECTION	44	/* projection */
#define	RIPCODE_RELATIVEDETAIL	45	/* relativedetail */
#define	RIPCODE_REVORIENTATION	46	/* reverseorientation */
#define	RIPCODE_ROTATE		47	/* rotate */
#define	RIPCODE_SCALE		48	/* scale */
#define	RIPCODE_SIDES		49	/* sides */
#define	RIPCODE_SKEW		50	/* skew */
#define	RIPCODE_SOLIDBEGIN	51	/* solidbegin */
#define	RIPCODE_SOLIDEND	52	/* solidend */
#define	RIPCODE_SPHERE		53	/* sphere */
#define	RIPCODE_XXXXXXXX	54	/* used to be string */
#define	RIPCODE_SURFACE		55	/* surface */
#define	RIPCODE_TEXTCOORDS	56	/* textcoords */
#define	RIPCODE_TORUS		57	/* torus */
#define	RIPCODE_TRANSFORM	58	/* transform */
#define	RIPCODE_TRANSFORMBEGIN	59	/* transformbegin */
#define	RIPCODE_TRANSFORMEND	60	/* transformend */
#define	RIPCODE_TRANSLATE	61	/* translate */
#define	RIPCODE_TRIMCURVE	62	/* trimcurve */
#define	RIPCODE_WORLDBEGIN	63	/* worldbegin */
#define	RIPCODE_WORLDEND	64	/* worldend */
