#ifndef _H_RibGenPlugIn_common
#define _H_RibGenPlugIn_common

#include <Components.h>

#define RibGenCompType	'RGEN'
#define RibGenFileType	'RGEN'

#define kRibGen_FirstSelector		1000
#define kRibGen_LastSelector		1005

#define kRibGen_Init				1000
#define kRibGen_Modify				1001
#define kRibGen_Generate			1002
#define kRibGen_GenToFile			1003
#define kRibGen_GenToFileRef		1004
#define kRibGen_Cleanup				1005

#define RG_NO_ERR					0
#define RG_USER_CANCELLED			1
#define RG_INVALID_CALL				-9001
#define RG_OPEN_FAILURE				-9002
#define RG_PLUGIN_NOTFOUND			-9003
#define RG_COMPONENT_ERR			-9004
#define RG_BAD_OBJECT				-9005
#define RG_MEM_FULL					-9006
#define RG_BAD_PARAM				-9007
#define RG_FOPEN_ERR				-9008
#define RG_DISK_FULL				-9009
#define RG_RIBGEN_ERR				-9010

typedef struct {
	void	(*cbRibGenProgress)(float);
} RibGen_Callbacks, *RibGen_CallbacksPtr;

pascal ComponentResult cInit(ComponentInstance ci, Handle plugInData, RibGen_CallbacksPtr callbacks)
 = {0x2f3c, 8, kRibGen_Init, 0x7000, 0xa82a};
pascal ComponentResult cModify(ComponentInstance ci, Handle plugInData, Handle object)
 = {0x2f3c, 8, kRibGen_Modify, 0x7000, 0xa82a};
pascal ComponentResult cGenerate(ComponentInstance ci, Handle plugInData, Handle object, float time, Handle rib)
 = {0x2f3c, 16, kRibGen_Generate, 0x7000, 0xa82a};
pascal ComponentResult cGenToFile(ComponentInstance ci, Handle plugInData, Handle object, float time, FSSpec *file)
 = {0x2f3c, 16, kRibGen_GenToFile, 0x7000, 0xa82a};
pascal ComponentResult cGenToFileRef(ComponentInstance ci, Handle plugInData, Handle object, float time, short fileRef)
 = {0x2f3c, 14, kRibGen_GenToFileRef, 0x7000, 0xa82a};
pascal ComponentResult cCleanup(ComponentInstance ci, Handle plugInData)
 = {0x2f3c, 4, kRibGen_Cleanup, 0x7000, 0xa82a};

#endif /* _H_RibGenPlugIn_common */