#include "TestRibGenPlugIn.h"
#include "RibGenPlugIn.h"
#include <LibRibFace.h>
#include <MacDefines.h>

typedef struct {
	long	dummy;
} Storage_Struct, **Storage_H;

Storage_H sStorage = NULL;

static Component sComponent = NULL;

static Component RegisterLibRibComponent()
{
	HFileInfo					pb;
	Str255						name;
	long						dirID;
	OSErr						err = noErr;
	Component					result = NULL;
	short						resRef;
	ComponentResourceHandle		crh = NULL;
	short						index;
	
	if (HGetVol(NULL, &pb.ioVRefNum, &dirID) != noErr)
		return NULL;
	
	pb.ioNamePtr = name;
	
	for (pb.ioFDirIndex = 1 ; err == noErr && result == NULL ; pb.ioFDirIndex++) {
		pb.ioDirID = dirID;
		if ((err = PBGetCatInfo((CInfoPBPtr)&pb, FALSE)) == noErr) {
			if (!(pb.ioFlAttrib & ATTRIB_DIRECTORY) && pb.ioFlFndrInfo.fdType == 'thng') {
				if ((resRef = HOpenResFile(pb.ioVRefNum, dirID, name, fsRdPerm)) != -1) {
					index = 1;
					do {
						if ((crh = (ComponentResourceHandle)Get1IndResource('thng', index++)) != NULL) {
							if ((**crh).cd.componentType == kLibRibComponentType &&
							  (**crh).cd.componentSubType == kLibRibComponentSubType) {
								result = RegisterComponentResource(crh, 0);
							}
							ReleaseResource((Handle)crh);
						 }
					} while (result == NULL && crh != NULL);
					CloseResFile(resRef);
				}
			}
		}
	}
	return result;
}

OSErr TestRibGenPlugIn_Open(void)
{
	OSErr err;
	
	if (!LibRibFace_IsRegistered())
		if ((sComponent = RegisterLibRibComponent()) == NULL)
			return fnfErr;
	
	if ((sStorage = (Storage_H)NewHandleClear(sizeof(Storage_Struct))) == NULL)
		return memFullErr;
		
	MoveHHi((Handle)sStorage);
	HLock((Handle)sStorage);
	
	if ((err = OpenPlugIn()) != noErr) {
		HUnlock((Handle)sStorage);
		DisposHandle((Handle)sStorage);
		sStorage = NULL;
	}
			
	return err;
}

OSErr TestRibGenPlugIn_Close(void)
{
	ClosePlugIn();
	
	HUnlock((Handle)sStorage);
	DisposHandle((Handle)sStorage);

	if (sComponent) {
		UnregisterComponent(sComponent);
		sComponent = NULL;
	}
			
	return noErr;
}
